#include <string.h>
#include <stdarg.h>

#include "console.h"
#include "common.h"
#include "osd.h"

#include <SDL.h>

#include <ctype.h>

#define	BLNKW	(2)	/* ; */
#define	BLNKH	(2)	/* ; */


SDL_Surface *JFont::ZFont = NULL;	// ѥեȥǡեؤΥݥ
SDL_Surface *JFont::HFont = NULL;	// ȾѥեȥǡեؤΥݥ
int JFont::zWidth  = 0;				// ʸ
int JFont::zHeight = 0;				//           ⤵
int JFont::hWidth  = 0;				// Ⱦʸ
int JFont::hHeight = 0;				//           ⤵


////////////////////////////////////////////////////////////////
// 󥹥ȥ饯
////////////////////////////////////////////////////////////////
JFont::JFont( void ){}

////////////////////////////////////////////////////////////////
// ǥȥ饯
////////////////////////////////////////////////////////////////
JFont::~JFont( void ){}


////////////////////////////////////////////////////////////////
// եȥե򳫤
////////////////////////////////////////////////////////////////
BOOL JFont::OpenFont( char *zfilename, char *hfilename )
{
	// ɹޤƤ˴
	CloseFont();
	
	// Ȥꤢ
	hWidth  = FSIZE;
	hHeight = hWidth * 2;
	
	// եȥեɤ߹
	HFont = LoadPNG( hfilename );
	ZFont = LoadPNG( zfilename );
	
	// եȥե뤬̵Хߡ
	if( !HFont ) HFont = SDL_CreateRGBSurface( SDLOP_SURFACE | SDL_SRCCOLORKEY, hWidth*96*2, hHeight* 2, 8, 0, 0, 0, 0 );
	if( !ZFont ) ZFont = SDL_CreateRGBSurface( SDLOP_SURFACE | SDL_SRCCOLORKEY, zWidth*96*2, zHeight*96, 8, 0, 0, 0, 0 );
	
	// ȾѤѤǥۤʤäϾۤ˹碌(ɽ)
	hWidth  = min( HFont->w, ZFont->w ) / 96 / 2;
	hHeight = min( HFont->h / 2, ZFont->h / 96 );
	zWidth  = hWidth * 2;
	zHeight = hHeight;
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// եȤ˴
////////////////////////////////////////////////////////////////
void JFont::CloseFont( void )
{
	if( HFont ){
		SDL_FreeSurface( HFont );
		HFont = NULL;
	}
	if( ZFont ){
		SDL_FreeSurface( ZFont );
		ZFont = NULL;
	}
}


////////////////////////////////////////////////////////////////
// Ⱦʸ
////////////////////////////////////////////////////////////////
void JFont::PutCharh( SDL_Surface* dst, int dx, int dy, Uint8 txt, Uint8 fg, Uint8 bg )
{
	int index = txt;
	
	// åԥ
	SDL_Rect sr,dr;
	sr.x = ( index % 128 ) * hWidth;
	sr.y = ( index / 128 ) * hHeight;
	dr.x = dx;
	dr.y = dy;
	sr.w = dr.w = hWidth;
	sr.h = dr.h = hHeight;
	
	// ž
	for( int y=0; y<sr.h; y++ )
		for( int x=0; x<sr.w; x++ )
			PSet( dst, dr.x + x, dr.y + y, (Uint8)( PGet( HFont, sr.x + x, sr.y + y ) ? fg : bg ) );
}


////////////////////////////////////////////////////////////////
// ʸ
////////////////////////////////////////////////////////////////
void JFont::PutCharz( SDL_Surface* dst, int dx, int dy, Uint16 txt, Uint8 fg, Uint8 bg )
{
	Uint8 high = (txt>>8) & 0xff;
	Uint8 low  =  txt     & 0xff;
	
	Convert2Jis( &high, &low );
	int index = ( high - 0x20 ) * 96 + low - 0x20;
	
	// åԥ
	SDL_Rect sr,dr;
	sr.x = ( index % 96 ) * zWidth;
	sr.y = ( index / 96 ) * zHeight;
	dr.x = dx;
	dr.y = dy;
	sr.w = dr.w = zWidth;
	sr.h = dr.h = zHeight;
	
	// ž
	for( int y=0; y<sr.h; y++ )
		for( int x=0; x<sr.w; x++ )
			PSet( dst, dr.x + x, dr.y + y, (Uint8)( PGet( ZFont, sr.x + x, sr.y + y ) ? fg : bg ) );
}







////////////////////////////////////////////////////////////////
// 󥹥ȥ饯
////////////////////////////////////////////////////////////////
ZCons::ZCons( void )
{
	Surf = NULL;
	Xmax = Ymax = x = y = 0;
	fgc = FC_WHITE;
	bgc = FC_BLACK;
	*Caption = '\0';
	
	pos.x = pos.y = pos.w = pos.h = 0;
}

////////////////////////////////////////////////////////////////
// ǥȥ饯
////////////////////////////////////////////////////////////////
ZCons::~ZCons( void ){}



////////////////////////////////////////////////////////////////
// 󥽡(ʸǥ)
////////////////////////////////////////////////////////////////
SDL_Surface *ZCons::Create( int winx, int winy, char *caption, int fcol, int bcol )
{
	int winxr = winx * hWidth  + BLNKW * 2;
	int winyr = winy * hHeight + BLNKH * 2;
	
	return CreateRes( winxr, winyr, caption, fcol, bcol );
}


////////////////////////////////////////////////////////////////
// 󥽡(٤ǥ)
////////////////////////////////////////////////////////////////
SDL_Surface *ZCons::CreateRes( int winx, int winy, char *caption, int fcol, int bcol )
{
	// Ѥߤʤ餤ä
	if( Surf ) SDL_FreeSurface( Surf );
	
	// ե
	Surf = SDL_CreateRGBSurface( SDLOP_SURFACE, winx, winy, 8, 0, 0, 0, 0 );
	if( !Surf ) return NULL;
	// եΤطʿɤĤ֤
	SDL_FillRect( Surf, NULL, bcol );
	
	// ѥåȺ(Ȥꤢ16)
	SDL_Color col[16];
	for( int i=0; i<16; i++ ){
		col[i].r = (i&4 ? 0xff : 0) >> (!(i&8) ? 1 : 0);
		col[i].g = (i&2 ? 0xff : 0) >> (!(i&8) ? 1 : 0);
		col[i].b = (i&1 ? 0xff : 0) >> (!(i&8) ? 1 : 0);
	}
	if( !SDL_SetColors( Surf, col, 0, 16 ) ){
		SDL_FreeSurface( Surf );
		Surf = NULL;
		return NULL;
	}
	SetColor( fcol, bcol );
	
	pos.w = Surf->w;
	pos.h = Surf->h;
	
	// Ĳʸ
	Xmax = ( Surf->w - BLNKW * 2 ) / hWidth;
	Ymax = ( Surf->h - BLNKH * 2 ) / hHeight;
	
	// ϰ
	con.x = BLNKW;
	con.y = BLNKH;
	con.w = Xmax * hWidth;
	con.h = Ymax * hHeight;
	
	if( caption ){	// ץ󤢤(ե졼ढ)ξ
		// ץ¸
		strncpy( Caption, caption, min( Xmax-2, (int)sizeof(Caption)-1 ) );
		
		// ե졼
		DrawFrame();
		
		// Ĳʸ
		Xmax -= 2;
		Ymax -= 2;
		
		// ϰ
		con.x += hWidth;
		con.y += hHeight;
		con.w  = Xmax * hWidth;
		con.h  = Ymax * hHeight;
	}
	
	x = y = 0;
	
	return Surf;
}


////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////
void ZCons::Locate( int xx, int yy )
{
	// üüå
	// ä鱦üü
	if( ( xx >= 0 )&&( xx < Xmax ) ) x = xx;
	else if( ( xx < 0 )&&( (Xmax-xx)>=0 ) ) x = Xmax + xx;
	
	if( ( yy >= 0 )&&( yy < Ymax ) ) y = yy;
	else if( ( yy < 0 )&&( (Ymax-yy)>=0 ) ) y = Ymax + yy;
}


////////////////////////////////////////////////////////////////
// (ܺɸ)
////////////////////////////////////////////////////////////////
void ZCons::LocateR( int xx, int yy )
{
	x += xx;
	if( x < 0 ) x = 0;
	if( x >= Xmax ) x = Xmax;
	
	y += yy;
	if( y < 0 ) y = 0;
	if( y >= Ymax ) y = Ymax;
}


////////////////////////////////////////////////////////////////
// 迧
////////////////////////////////////////////////////////////////
void ZCons::SetColor( Uint8 fg, Uint8 bg )
{
	fgc = fg;
	bgc = bg;
}

void ZCons::SetColor( Uint8 fg )
{
	fgc = fg;
}


////////////////////////////////////////////////////////////////
// ̾õ
////////////////////////////////////////////////////////////////
void ZCons::Cls( void )
{
	// ϰϤطʿɤĤ֤
	if( Surf ) SDL_FillRect( Surf, &con, bgc );
	// ᤹ۡ
	x = y = 0;
}


////////////////////////////////////////////////////////////////
// Ⱦ1ʸ
////////////////////////////////////////////////////////////////
void ZCons::PutCharH( Uint8 c )
{
	JFont::PutCharh( Surf, x * hWidth + con.x, y * hHeight + con.y, c, fgc, bgc );
	
	// Υ
	x++;
}


////////////////////////////////////////////////////////////////
// 1ʸ
////////////////////////////////////////////////////////////////
void ZCons::PutCharZ( Uint16 c )
{
	JFont::PutCharz( Surf, x * hWidth + con.x, y * hHeight + con.y, c, fgc, bgc );
	
	// Υ
	x += 2;
}


////////////////////////////////////////////////////////////////
// ʸ(ʸб)
////////////////////////////////////////////////////////////////
void ZCons::Print( char *text, ... )
{
	Uint8 buf[1024];
	int num = 0;
	va_list ap;
	
	if( !Surf ) return;
	
	// ĹŸʸѴ
	va_start( ap, text );
	num = vsprintf( (char *)buf, text, ap );
	
	for( int i=0; i<num; i++ ){
		if( isprint( buf[i] ) )
			PutCharH( buf[i] );
		else{
			PutCharZ( buf[i]<<8 | buf[i+1] );
			i++;
		}
	}
}


////////////////////////////////////////////////////////////////
// ʸ(ʸб)
////////////////////////////////////////////////////////////////
void ZCons::Printf( char *text, ... )
{
	Uint8 buf[1024];
	int num = 0;
	va_list ap;
	
	if( !Surf ) return;
	
	// ĹŸʸѴ
	va_start( ap, text );
	num = vsprintf( (char *)buf, text, ap );
	
	for( int i=0; i<num; i++ ){
		switch( buf[i] ){
		case '\n':	// 
			x = 0;
			y++;
			break;
			
		default:	// ̤ʸ
			if( isprint( buf[i] ) )
				PutCharH( buf[i] );
			else{
				PutCharZ( buf[i]<<8 | buf[i+1] );
				i++;
			}
			
			// Υ
			if( x >= Xmax ){
				x = 0;
				y++;
			}
		}
		
		// ?
		if( y >= Ymax){
			y = Ymax - 1;
			ScrollUp();
		}
	}
}


////////////////////////////////////////////////////////////////
// ʸ(ͤ)
////////////////////////////////////////////////////////////////
void ZCons::Printfr( char *text, ... )
{
	char buf[1024];
	int num = 0;
	va_list ap;
	
	if( !Surf ) return;
	
	// ĹŸʸѴ
	va_start( ap, text );
	num = vsprintf( buf, text, ap );
	
	if( num > Xmax ) num = Xmax;
	Locate( -num, y );
	
	for( int i=0; i<num; i++ ){
		if( isprint( buf[i] ) )
			PutCharH( buf[i] );
		else{
			PutCharZ( buf[i]<<8 | buf[i+1] );
			i++;
		}
	}
}


////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////
void ZCons::DrawFrame( void )
{
	SDL_Rect frm;
	
	frm.x = con.x;
	frm.y = con.y + 4;
	frm.w = con.w;
	frm.h = con.h - 8;
	SDL_FillRect( Surf, &frm, fgc );
	
	frm.x += 1;
	frm.y += 1;
	frm.w -= 2;
	frm.h -= 2;
	SDL_FillRect( Surf, &frm, bgc );
	
	// ץ
	if( strlen( Caption ) > 0 ){
		Locate( 1, 0 );
		Print( " %s ", Caption );
	}
}


////////////////////////////////////////////////////////////////
// 륢å
////////////////////////////////////////////////////////////////
void ZCons::ScrollUp( void )
{
	SDL_Rect SPos,DPos;
	
	// ž
	SPos.x = con.x;
	SPos.y = con.y + hHeight;
	SPos.w = con.w;
	SPos.h = con.h - hHeight;
	
	// ž
	DPos.x = con.x;
	DPos.y = con.y;
	
	// 
	SDL_BlitSurface( Surf, &SPos, Surf, &DPos );
	
	// ϰϤطʿɤĤ֤
	DPos.x = con.x;
	DPos.y = con.y + con.h - hHeight;
	DPos.w = con.w;
	DPos.h = hHeight;
	SDL_FillRect( Surf, &DPos, bgc );
}


////////////////////////////////////////////////////////////////
// ꡼ɽ
////////////////////////////////////////////////////////////////
void ZCons::Show( SDL_Rect *p )
{
	if( p ){
		pos.x = p->x;
		pos.y = p->y;
	}
	
	SDL_BlitSurface( Surf, NULL, SDL_GetVideoSurface(), &pos );
}
