#include <SDL_endian.h>

#include "graph.h"
#include "common.h"
#include "debug.h"
#include "mc6847.h"
#include "osd.h"
#include "status.h"

// ̾復ɥ
#define	P6WINW		(WBBUF)
#define	P6WINH		(HBBUF)

// ե륹꡼󥦥ɥ
#define	P6WIFW		(320)
#define	P6WIFH		(200)

#ifdef USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
// ǥХå⡼ɥɥ
#define	P6DEBUGW	(P6WINW+vm->regw->Width())
#define	P6DEBUGH	(max(P6WINH,vm->regw->Height()+vm->memw->Height())+vm->monw->Height())
#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //


// ˥⡼ɻϥե륹꡼󡤥饤4:3ɽػ
// ե륹꡼⡼ɻϥơС4:3ɽػ
#ifdef USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
#define	DISPMON		(vm->cGlobal::MonDisp)
#define	DISPFULL	(!DISPMON  && vm->cGlobal::FullScreen)
#define	DISPSCAN	(!DISPMON  && vm->cGlobal::ScanLine)
#define	DISPNTSC	(!DISPMON  && !DISPFULL && vm->cGlobal::DispNTSC)
#define	DISPSTAT	(!DISPFULL && vm->cGlobal::StatDisp)

#else

#define	DISPFULL	(vm->cGlobal::FullScreen)
#define	DISPSCAN	(vm->cGlobal::ScanLine)
#define	DISPNTSC	(vm->cGlobal::DispNTSC&& !DISPFULL )
#define	DISPSTAT	(vm->cGlobal::StatDisp)

#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //


////////////////////////////////////////////////////////////////
// 󥹥ȥ饯
////////////////////////////////////////////////////////////////
DSP6::DSP6( VM6 *vm, const P6ID& id ) : P6DEVICE(vm,id)
{
	SBuf = NULL;
	ScrPos.x = ScrPos.y = ScrPos.w = ScrPos.h = 0;
	Bpp  = DEFAULT_COLOR_MODE;
	SLBr = DEFAULT_SCANLINEBR;
}


////////////////////////////////////////////////////////////////
// ǥȥ饯
////////////////////////////////////////////////////////////////
DSP6::~DSP6( void )
{
	if( SBuf && ( SBuf != vm->vdg->GetSurf() ) ) SDL_FreeSurface( SBuf );
}


////////////////////////////////////////////////////////////////
// 
//
// :	ʤ
// :	BOOL	TRUE: FALSE:
////////////////////////////////////////////////////////////////
BOOL DSP6::Init( int bpp, int br )
{
	PRINTD( GRP_LOG, "[GRP][Init]\n" );
	
	Bpp  = bpp;
	SLBr = br;
	
	// ꡼󥵡ե
	if( !SetScreenSurface() ) return FALSE;
	
	// ơС
	if( !vm->staw->Init() ) return FALSE;
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ꡼󥵡ե
//
// :	ʤ
// :	BOOL	TRUE: FALSE:
////////////////////////////////////////////////////////////////
BOOL DSP6::SetScreenSurface( void )
{
	PRINTD( GRP_LOG, "[GRP][SetScreenSurface]\n" );
	
	#ifdef USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	if( DISPMON ){	// ˥⡼?
		
		PRINTD2( GRP_LOG, " -> Monitor Mode ( X:%d Y:%d )\n", P6DEBUGW, P6DEBUGH );
		
		if( !SDL_SetVideoMode( P6DEBUGW, P6DEBUGH, Bpp, SDLOP_SCREEN ) ) return FALSE;
	}else
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	{
		int x = ( DISPFULL ? P6WIFW : P6WINW ) * ( DISPSCAN ? 2 : 1 );
		int y = ( DISPFULL ? P6WIFH : ( DISPNTSC ? HBBUS : P6WINH ) ) * ( DISPSCAN ? 2 : 1 );
		
		if( DISPFULL ){	// ե륹꡼?
		#ifdef __APPLE__
			// Mac Υե륹꡼ 640x480, 800x600, 1024x768 ˸¤餷by Windy
			x = 640;
			y = 480;
		#endif
			
			PRINTD2( GRP_LOG, " -> FullScreen ( X:%d Y:%d )\n", x, y );
			
			// ޥä
			SDL_ShowCursor( SDL_DISABLE );
			// ꡼󥵡ե
			if( !SDL_SetVideoMode( x, y, Bpp, SDLOP_SCREEN | SDL_FULLSCREEN ) ) return FALSE;
			
			PRINTD3( GRP_LOG, " -> OK ( %d x %d x %d )\n", SDL_GetVideoSurface()->w, SDL_GetVideoSurface()->h, SDL_GetVideoSurface()->format->BitsPerPixel );
			
		}else{
			// ơСɽ?
			if( DISPSTAT ) y += vm->staw->Height();
			
			PRINTD2( GRP_LOG, " -> Window ( X:%d Y:%d )\n", x, y );
			
			// ꡼󥵡ե
			if( !SDL_SetVideoMode( x, y, Bpp, SDLOP_SCREEN ) ) return FALSE;
		}
	}
	
	// ե륹꡼Ǥʤ?
	if( !DISPFULL ){
		// ɥץ
		SDL_WM_SetCaption( vm->cGlobal::WCaption, "" );
		// ޥɽ
		SDL_ShowCursor( SDL_ENABLE );
	}
	
	// ꡼󥵡ե˥ѥåȤ򤹤
	if( SDL_GetVideoSurface()->format->BitsPerPixel == 8 )
		if( !vm->vdg->SetPalette( SDL_GetVideoSurface() ) ) return FALSE;
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ꡼󥵥ѹ
//
// :	ʤ
// :	SDL_Surface *	꡼󥵡եؤΥݥ
////////////////////////////////////////////////////////////////
SDL_Surface *DSP6::ResizeScreen( void )
{
	PRINTD( GRP_LOG, "[GRP][ResizeScreen]\n" );
	
	int x,y;
	SDL_Surface *scr  = SDL_GetVideoSurface();	// ꡼󥵡եؤΥݥ󥿼
	
	// ɥå
	#ifdef USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	if( DISPMON ){	// ˥⡼?
		x = P6DEBUGW;
		y = P6DEBUGH;
	}else
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	{
		x = ( DISPFULL ? P6WIFW : P6WINW ) * ( DISPSCAN ? 2 : 1 );
		y = ( DISPFULL ? P6WIFH : ( DISPNTSC ? HBBUS : P6WINH ) ) * ( DISPSCAN ? 2 : 1 );
		
		// ơСɽ?
		if( !DISPFULL && DISPSTAT ) y += vm->staw->Height();
	}
	
	// ɥŬڤʤľ
	if( !scr || (x != scr->w) || (y != scr->h) ){
		SetScreenSurface();
		vm->staw->Init();	// ơС
	}
	
	return SDL_GetVideoSurface();
}


////////////////////////////////////////////////////////////////
// ̹
//
// :	ʤ
// :	ʤ
////////////////////////////////////////////////////////////////
void DSP6::DrawScreen( void )
{
	PRINTD( GRP_LOG, "[GRP][DrawScreen]\n" );
	
	SDL_Surface *scr  = SDL_GetVideoSurface();	// ꡼󥵡եؤΥݥ󥿼
	SDL_Surface *BBuf = vm->vdg->GetSurf();		// ХåХåեؤΥݥ󥿼
	
	if( !scr || !BBuf ) return;
	
	// ꡼󥵡եblit
	PRINTD( GRP_LOG, " -> Blit" );
	
	#ifdef USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	if( DISPMON ){	// ˥⡼?
		PRINTD( GRP_LOG, " -> Monitor" );
		
		// ХåХåե
		ScrPos.x = 0;
		ScrPos.y = 0;
		SDL_BlitSurface( BBuf, NULL, scr, &ScrPos );
		
		// ˥ɥ
		ScrPos.x = 0;
		ScrPos.y = max( P6WINH, vm->regw->Height() + vm->memw->Height() );
		vm->monw->Show( &ScrPos );
		
		// 쥸ɥ
		ScrPos.x = P6WINW;
		ScrPos.y = 0;
		vm->regw->Show( &ScrPos );
		
		// ꥦɥ
		ScrPos.x = P6WINW;
		ScrPos.y = vm->regw->Height();
		vm->memw->Show( &ScrPos );
	}else
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	{
		UpdateSubBuf();	// ֥Хåե
		
		if( DISPFULL ){	// ե륹꡼
			PRINTD( GRP_LOG, " -> FullScreen(No 4:3)" );
			// ե륹꡼λ4:3ɽ̵
			ScrPos.x = ( scr->w - SBuf->w )/2;
			ScrPos.y = ( scr->h - SBuf->h )/2;
			ScrPos.w = SBuf->w;
			ScrPos.h = SBuf->h;
			SDL_BlitSurface( SBuf, NULL, scr, &ScrPos );
		}else{			// ե륹꡼Ǥʤ
			PRINTD( GRP_LOG, " -> Window" );
			SDL_BlitSurface( SBuf, NULL, scr, NULL );
		}
		
		// ơС
		if( DISPSTAT ){
			PRINTD( GRP_LOG, " -> Statusbar" );
			
			// ơС򹹿blit
			vm->staw->Update();
		}
	}
	
	PRINTD( GRP_LOG, " -> OK\n" );
	
	// եå
 	SDL_Flip( scr );
}


////////////////////////////////////////////////////////////////
// ͭ꡼
//
// :	ʤ
// :	int		ͭ꡼ԥ
////////////////////////////////////////////////////////////////
int DSP6::ScreenX( void )
{
	return P6WINW * ( DISPSCAN ? 2 : 1 );
}


////////////////////////////////////////////////////////////////
// ͭ꡼⤵
//
// :	ʤ
// :	int		ͭ꡼⤵ԥ
////////////////////////////////////////////////////////////////
int DSP6::ScreenY( void )
{
	return ( DISPNTSC ? HBBUS : P6WINH ) * ( DISPSCAN ? 2 : 1 );
}


////////////////////////////////////////////////////////////////
// ֥Хåե
//
// :	ʤ
// :	BOOL	TRUE: FALSE:
////////////////////////////////////////////////////////////////
#define	RESO43		(8)		/* ֿ׻ʬǽ(1饤RESO43ʬ䤹) */
#define	THRE43		(0)		/* ֿΤ(礭ֿ) */
BOOL DSP6::UpdateSubBuf( void )
{
	PRINTD( GRP_LOG, "[GRP][UpdateSubBuf]\n" );
	
	SDL_Surface *BBuf = vm->vdg->GetSurf();
	
	if( !BBuf ) return FALSE;
	
	if( !RefreshSubBuf() ) return FALSE;
	
	if( SDL_MUSTLOCK( BBuf ) ) SDL_LockSurface( BBuf );
	if( SDL_MUSTLOCK( SBuf ) ) SDL_LockSurface( SBuf );
	
	if( DISPNTSC ){	// 4:3ɽͭξ
		PRINTD( GRP_LOG, " -> 4:3" );
		if( DISPSCAN ){	// 饤󤢤ξ
			PRINTD( GRP_LOG, " -> ScanLine" );
			switch( SBuf->format->BitsPerPixel ){
			case 8:		// 8bit⡼
				PRINTD( GRP_LOG, " -> 8bit" );
				for( int y=0; y<SBuf->h; y+=2 ){
					int y0 = ( y * BBuf->h ) / SBuf->h;
					
					DWORD *soff = (DWORD *)BBuf->pixels + BBuf->pitch/sizeof(DWORD) * y0;
					DWORD *doff = (DWORD *)SBuf->pixels + SBuf->pitch/sizeof(DWORD) * y;
					DWORD *eoff = doff + SBuf->pitch/sizeof(DWORD);
					DWORD s, d;
					
					// 8bitλֿʤ
					for( int x=0; x<(int)(BBuf->w/sizeof(DWORD)); x++ ){
						BYTE b1,b2,b3,b4;
						s = *soff++;
						DWTOB( s, b1, b2, b3, b4 );
						d = BTODW( b4, b4, b3, b3 );
						*doff++ = d;
						*eoff++ = d|0x80808080;
						d = BTODW( b2, b2, b1, b1 );
						*doff++ = d;
						*eoff++ = d|0x80808080;
					}
				}
				break;
				
			case 16:	// 16bit⡼
				PRINTD( GRP_LOG, " -> 16bit" );
				for( int y=0; y<SBuf->h; y+=2 ){
					int y0 = ( y * BBuf->h ) / SBuf->h;
					int a1 = ( y * BBuf->h * RESO43 ) / SBuf->h - y0 * RESO43;
					int a2 = RESO43 - a1;
					
					BYTE *soff = (BYTE *)BBuf->pixels + BBuf->pitch * y0;
					DWORD *doff = (DWORD *)SBuf->pixels + ( SBuf->pitch * y ) / sizeof(DWORD);
					DWORD *eoff = doff + SBuf->pitch / sizeof(DWORD);
					
					
					// ͤ?
					if( a1 > THRE43 && a2 > THRE43 ){
						for( int x=0; x<(int)BBuf->w; x++ ){
							BYTE d1 = *(soff);
							BYTE d2 = *((soff++)+BBuf->pitch);
							
							BYTE r = ( BBuf->format->palette->colors[d1].r * a2 + BBuf->format->palette->colors[d2].r * a1 ) / RESO43;
							BYTE g = ( BBuf->format->palette->colors[d1].g * a2 + BBuf->format->palette->colors[d2].g * a1 ) / RESO43;
							BYTE b = ( BBuf->format->palette->colors[d1].b * a2 + BBuf->format->palette->colors[d2].b * a1 ) / RESO43;
							
							DWORD dd = ( (DWORD)( r & 0xf8 ) << 8 ) | ( (DWORD)( g & 0xfc ) << 3 ) | ( (DWORD)( b & 0xf8 ) >> 3 );
							dd |= dd << 16;
							*(doff++) = dd;
							
							r = ( r * SLBr ) / 100;
							g = ( g * SLBr ) / 100;
							b = ( b * SLBr ) / 100;
							
							DWORD ed = ( (DWORD)( r & 0xf8 ) << 8 ) | ( (DWORD)( g & 0xfc ) << 3 ) | ( (DWORD)( b & 0xf8 ) >> 3 );
							ed |= ed << 16;
							*(eoff++) = ed;
						}
					}else{
						for( int x=0; x<(int)BBuf->w; x++ ){
							BYTE d1 = *(soff++);
							
							BYTE r = BBuf->format->palette->colors[d1].r;
							BYTE g = BBuf->format->palette->colors[d1].g;
							BYTE b = BBuf->format->palette->colors[d1].b;
							
							DWORD dd = ( (DWORD)( r & 0xf8 ) << 8 ) | ( (DWORD)( g & 0xfc ) << 3 ) | ( (DWORD)( b & 0xf8 ) >> 3 );
							dd |= dd << 16;
							*(doff++) = dd;
							
							r = ( r * SLBr ) / 100;
							g = ( g * SLBr ) / 100;
							b = ( b * SLBr ) / 100;
							
							DWORD ed = ( (DWORD)( r & 0xf8 ) << 8 ) | ( (DWORD)( g & 0xfc ) << 3 ) | ( (DWORD)( b & 0xf8 ) >> 3 );
							ed |= ed << 16;
							*(eoff++) = ed;
						}
					}
				}
				break;
				
			case 24:	// 24bit⡼
				PRINTD( GRP_LOG, " -> 24bit" );
				for( int y=0; y<SBuf->h; y+=2 ){
					int y0 = ( y * BBuf->h ) / SBuf->h;
					int a1 = ( y * BBuf->h * RESO43 ) / SBuf->h - y0 * RESO43;
					int a2 = RESO43 - a1;
					
					BYTE *soff = (BYTE *)BBuf->pixels + BBuf->pitch * y0;
					BYTE *doff = (BYTE *)SBuf->pixels + SBuf->pitch * y;
					BYTE *eoff = doff + SBuf->pitch;
					
					
					// ͤ?
					if( a1 > THRE43 && a2 > THRE43 ){
						for( int x=0; x<(int)BBuf->w; x++ ){
							BYTE d1 = *(soff);
							BYTE d2 = *((soff++)+BBuf->pitch);
							
							BYTE r = ( BBuf->format->palette->colors[d1].r * a2 + BBuf->format->palette->colors[d2].r * a1 ) / RESO43;
							BYTE g = ( BBuf->format->palette->colors[d1].g * a2 + BBuf->format->palette->colors[d2].g * a1 ) / RESO43;
							BYTE b = ( BBuf->format->palette->colors[d1].b * a2 + BBuf->format->palette->colors[d2].b * a1 ) / RESO43;
							
							PUT3BYTE( b, g, r, doff );
							PUT3BYTE( b, g, r, doff );
							
							r = ( r * SLBr ) / 100;
							g = ( g * SLBr ) / 100;
							b = ( b * SLBr ) / 100;
							
							PUT3BYTE( b, g, r, eoff );
							PUT3BYTE( b, g, r, eoff );
						}
					}else{
						for( int x=0; x<(int)BBuf->w; x++ ){
							BYTE d1 = *(soff++);
							
							BYTE r = BBuf->format->palette->colors[d1].r;
							BYTE g = BBuf->format->palette->colors[d1].g;
							BYTE b = BBuf->format->palette->colors[d1].b;
							
							PUT3BYTE( b, g, r, doff );
							PUT3BYTE( b, g, r, doff );
							
							r = ( r * SLBr ) / 100;
							g = ( g * SLBr ) / 100;
							b = ( b * SLBr ) / 100;
							
							PUT3BYTE( b, g, r, eoff );
							PUT3BYTE( b, g, r, eoff );
						}
					}
				}
			}
		}else{			// 饤ʤξ
			PRINTD( GRP_LOG, " -> No ScanLine" );
			switch( SBuf->format->BitsPerPixel ){
			case 8:		// 8bit⡼
				PRINTD( GRP_LOG, " -> 8bit" );
				for( int y=0; y<SBuf->h; y++ ){
					int y0 = ( y * BBuf->h ) / SBuf->h;
					
					BYTE *soff = (BYTE *)BBuf->pixels + BBuf->pitch * y0;
					BYTE *doff = (BYTE *)SBuf->pixels + SBuf->pitch * y;
					
					// 8bitλֿʤ
					memcpy( doff, soff, SBuf->pitch );
				}
				break;
				
			case 16:	// 16bit⡼
				PRINTD( GRP_LOG, " -> 16bit" );
				for( int y=0; y<SBuf->h; y++ ){
					int y0 = ( y * BBuf->h ) / SBuf->h;
					int a1 = ( y * BBuf->h * RESO43 ) / SBuf->h - y0 * RESO43;
					int a2 = RESO43 - a1;
					
					BYTE *soff = (BYTE *)BBuf->pixels + BBuf->pitch * y0;
					WORD *doff = (WORD *)SBuf->pixels + ( SBuf->pitch * y ) / sizeof(WORD);
					
					// ͤ?
					if( a1 > THRE43 && a2 > THRE43 ){
						for( int x=0; x<BBuf->pitch; x++ ){
							BYTE d1 = *(soff);
							BYTE d2 = *((soff++)+BBuf->pitch);
							WORD dd = ( (WORD)( ( ( BBuf->format->palette->colors[d1].r * a2 + BBuf->format->palette->colors[d2].r * a1 ) / RESO43 ) & 0xf8 ) << 8 ) |
									  ( (WORD)( ( ( BBuf->format->palette->colors[d1].g * a2 + BBuf->format->palette->colors[d2].g * a1 ) / RESO43 ) & 0xfc ) << 3 ) |
									  ( (WORD)( ( ( BBuf->format->palette->colors[d1].b * a2 + BBuf->format->palette->colors[d2].b * a1 ) / RESO43 ) & 0xf8 ) >> 3 );
							*(doff++) = dd;
						}
					}else{
						for( int x=0; x<BBuf->pitch; x++ ){
							BYTE d1 = *(soff++);
							WORD dd = ( (WORD)( BBuf->format->palette->colors[d1].r & 0xf8 ) << 8 ) |
									  ( (WORD)( BBuf->format->palette->colors[d1].g & 0xfc ) << 3 ) |
									  ( (WORD)( BBuf->format->palette->colors[d1].b & 0xf8 ) >> 3 );
							*(doff++) = dd;
						}
					}
				}
				break;
				
			case 24:	// 24bit⡼
				PRINTD( GRP_LOG, " -> 24bit" );
				for( int y=0; y<SBuf->h; y++ ){
					int y0 = ( y * BBuf->h ) / SBuf->h;
					int a1 = ( y * BBuf->h * RESO43 ) / SBuf->h - y0 * RESO43;
					int a2 = RESO43 - a1;
					
					BYTE *soff = (BYTE *)BBuf->pixels + BBuf->pitch * y0;
					BYTE *doff = (BYTE *)SBuf->pixels + SBuf->pitch * y;
					
					// ͤ?
					if( a1 > THRE43 && a2 > THRE43 ){
						for( int x=0; x<BBuf->pitch; x++ ){
							BYTE d1 = *(soff);
							BYTE d2 = *((soff++)+BBuf->pitch);
							
							BYTE r = ( BBuf->format->palette->colors[d1].r * a2 + BBuf->format->palette->colors[d2].r * a1 ) / RESO43;
							BYTE g = ( BBuf->format->palette->colors[d1].g * a2 + BBuf->format->palette->colors[d2].g * a1 ) / RESO43;
							BYTE b = ( BBuf->format->palette->colors[d1].b * a2 + BBuf->format->palette->colors[d2].b * a1 ) / RESO43;
							
							PUT3BYTE( b, g, r, doff );
						}
					}else{
						for( int x=0; x<BBuf->pitch; x++ ){
							BYTE d1 = *(soff++);
							
							BYTE r = BBuf->format->palette->colors[d1].r;
							BYTE g = BBuf->format->palette->colors[d1].g;
							BYTE b = BBuf->format->palette->colors[d1].b;
							
							PUT3BYTE( b, g, r, doff );
						}
					}
				}
			}
		}
	}else{			// 4:3ɽ̵ξ (8bit⡼ɤ˸ꤵ)
		PRINTD( GRP_LOG, " -> No 4:3(8bit)" );
		if( DISPSCAN ){	// 饤󤢤ξ
			PRINTD( GRP_LOG, " -> ScanLine" );
			for( int y=0; y<BBuf->h; y++ ){
				DWORD *soff = (DWORD *)BBuf->pixels + BBuf->pitch/sizeof(DWORD) * y;
				DWORD *doff = (DWORD *)SBuf->pixels + SBuf->pitch/sizeof(DWORD) * y*2;
				DWORD *eoff = doff + SBuf->pitch/sizeof(DWORD);
				DWORD s, d;
				
				for( int x=0; x<(int)(BBuf->w/sizeof(DWORD)); x++ ){
					BYTE b1,b2,b3,b4;
					s = *soff++;
					DWTOB( s, b1, b2, b3, b4 );
					d = BTODW( b4, b4, b3, b3 );
					*doff++ = d;
					*eoff++ = d|0x80808080;
					d = BTODW( b2, b2, b1, b1 );
					*doff++ = d;
					*eoff++ = d|0x80808080;
				}
			}
		}else{			// 饤ʤξ
			PRINTD( GRP_LOG, " -> No ScanLine" );
			// ʤˤ⤷ʤΤƱʤΤǥѥ
		}
	}
	
	PRINTD( GRP_LOG, " -> OK\n" );
	
	
	if( SDL_MUSTLOCK( BBuf ) ) SDL_UnlockSurface( BBuf );
	if( SDL_MUSTLOCK( SBuf ) ) SDL_UnlockSurface( SBuf );
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ֥Хåեեå
//
// :	ʤ
// :	BOOL	TRUE: FALSE:
////////////////////////////////////////////////////////////////
BOOL DSP6::RefreshSubBuf( void )
{
	PRINTD( GRP_LOG, "[GRP][RefreshSubBuf]\n" );
	
	SDL_Surface *BBuf = vm->vdg->GetSurf();
	
	if( DISPNTSC || DISPSCAN ){	// 4:3ɽͭ ޤ 饤󤢤ξ硤SBufɬ
		if( SBuf && SBuf != BBuf ){
			// ѤäƤʤOK
			if( SBuf->w == ScreenX() && SBuf->h == ScreenY() ){
				PRINTD2( GRP_LOG, " X:%d Y:%d -> OK\n", SBuf->w, SBuf->h );
				return TRUE;
			// ѤäƤϰö
			}else{
				SDL_FreeSurface( SBuf );
			}
		}
		
		// ֥Хåե
		int bpp = DISPNTSC ? Bpp : 8;
		PRINTD3( GRP_LOG, " Create SubBuffer X:%d Y:%d BPP:%d\n", ScreenX(), ScreenY(), bpp );
		SBuf = SDL_CreateRGBSurface( SDLOP_SURFACE, ScreenX(), ScreenY(), bpp, 0, 0, 0, 0 );
		if( !SBuf ) return FALSE;
		
		// ѥå
		if( bpp == 8 )
			if( !vm->vdg->SetPalette( SBuf ) ) return FALSE;
		
	}else{						// 4:3ɽ̵  饤ʤξ硤SBuf
		if( SBuf && SBuf != BBuf ) SDL_FreeSurface( SBuf );
		SBuf = BBuf;	// ֥Хåե = ХåХåե
		PRINTD2( GRP_LOG, " = BackBuffer X:%d Y:%d -> OK\n", SBuf->w, SBuf->h );
	}
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ʥåץå
//
// :	path	꡼󥷥åȳǼѥ
// :	ʤ
////////////////////////////////////////////////////////////////
void DSP6::SnapShot( char *path )
{
	PRINTD( GRP_LOG, "[GRP][SnapShot]\n" );
	
	char img_file[PATH_MAX];
	char img_name[PATH_MAX] = "P6V";
	char img_ext[]          = ".png";
	int Index = 0;
	
	// ꡼󥷥åȳǼեʤХ顼
	if( !OSD_FileExist( path ) ) return;
	
	// ꡼󥷥åȥե̾
	do{
		sprintf( img_file, "%s%s%03d%s", path, img_name, ++Index, img_ext );
	}while( OSD_FileExist( img_file ) || (Index > 999) );
	
	// Ϣ֤ͭʤPNG¸
	if( !(Index > 999) ) SavePNG( img_file, SBuf, NULL );
}


// [] http://www.joochan.net/rgb-convert.html
// RGB <-> YIQ

// Y =  0.2989 * R + 0.5866 * G + 0.1145 * B
// I =  0.5959 * R - 0.2750 * G - 0.3210 * B
// Q =  0.2065 * R - 0.4969 * G + 0.2904 * B

// R = Y + 0.9489 * I + 0.6561 * Q
// G = Y - 0.2645 * I - 0.6847 * Q
// B = Y - 1.1270 * I + 1.8050 * Q
