#ifndef MC6847_H_INCLUDED
#define MC6847_H_INCLUDED

#include "pc6001v.h"
#include "device.h"
#include "ini.h"
#include "p6device.h"

// ХåХåե
#define	WBBUF		(376-16)
#define	HBBUF		(242-12)

// Ф̹⤵
#define	HBBUS		(282-12)

////////////////////////////////////////////////////////////////
// 饹
////////////////////////////////////////////////////////////////
class VDG6 : public P6DEVENT, public IDoko {
protected:
	SDL_Surface *bbuf;		// ХåХåե
	SDL_Color GPal[256];	// ѥå
	
	int Mode4Col;			// ⡼4顼⡼ 0: 1:/ 2:/ 3:ԥ/ 4:/ԥ
	BOOL CrtDisp;			// CRTɽ TRUE:ɽ FALSE:ɽ
	BOOL N60Win;			// ɥ TRUE:N60 FALSE:N60m
	
	WORD VramAddr;			// VRAM ɥ쥹 0:0xc200 1:0xe200 2:0x8200 3:0xa200
	WORD AttrAddr;			// ATTR ɥ쥹 0:0xc000 1:0xe000 2:0x8000 3:0xa000
	
	// ѥ
	DWORD BCol;				// ܡ顼
	
	// Ʊ
	int VLines;				// ľɽ饤
	int VLcnt;				// ɽ饤󥫥
	int HWait;				// ʿɽ֥(BUSREQ֤CPUå)
	
	virtual void SetVramAddr( BYTE ) = 0;	// VRAM ɥ쥹ڤؤ
	virtual void CrtKill() = 0;				// CRT KILL
	virtual void Vram2Screen() = 0;			// VRAM Ƥ ХåХåե
	
	BOOL RefreshBackBuf();					// ХåХåեեå
	
	BYTE GetAttr( WORD );					// ȥӥ塼ȥǡ
	BYTE GetVram( WORD );					// VRAMǡ
	
	BYTE GetFont1( WORD );					// Font1ǡ
	
	void ChangeBUSREQ();					// BUSREQѲ
	
	void Putc_M1( int, int, WORD );			// ⡼1   1ʸPUT
	void Putc_M2( int, int, WORD );			// ⡼2-1 1ʸPUT
	
	virtual void Mode_12() = 0;				// Mode 1,2 sub
	virtual void Mode_34() = 0;				// Mode 3,4 sub
	
public:
	VDG6( VM6 *, const P6ID& );				// 󥹥ȥ饯
	virtual ~VDG6();						// ǥȥ饯
	
	void EventCallback( int, int );			// ٥ȥХåؿ
	
	virtual BOOL Init();					// 
	virtual BOOL LoadFont( char *, char * ){ return TRUE; }	// VDGեɹ
	
	BOOL UpdateBackBuf();					// ХåХåե
	SDL_Surface *GetSurf(){ return bbuf; }	// ХåХåեؤΥݥ󥿼
	
	BOOL SetPalette( SDL_Surface * );		// ե˥ѥå
	
	int GetMode4Color(){ return Mode4Col; }	// ⡼4顼⡼ɼ
	void SetMode4Color( int col ){ Mode4Col = col; }	//        
	
	BOOL GetWinSize(){ return N60Win; }		// ɥ
	
	BOOL GetCrtDisp(){ return CrtDisp; }	// CRTɽּ
	void SetCrtDisp( BOOL );				// CRTɽ
	
};


class VDG60 : public VDG6, public Device {
protected:
	BYTE *CGRomV;							// CG ROM(VDG)
	
	void SetVramAddr( BYTE );				// VRAM ɥ쥹ڤؤ
	void CrtKill();							// CRT KILL
	void Vram2Screen();						// VRAM Ƥ ХåХåե
	
	BYTE GetFontV( WORD );					// VDG Fontǡ
	
	void Putc_M0( int, int, WORD );			// ⡼0   1ʸPUT
	void Putc_M21( int, int, WORD );		// ⡼2-2 1ʸPUT
	void Mode_12();							// Mode 1,2 sub
	void Mode_34();							// Mode 3,4 sub
	
	// ǥХ
	static const Descriptor descriptor;
	static const InFuncPtr  indef[];
	static const OutFuncPtr outdef[];
	const Descriptor* GetDesc() const { return &descriptor; }
	
	// I/Oؿ
	inline void OutB0H( int, BYTE data ){ SetVramAddr( data ); }
	
public:
	VDG60( VM6 *, const ID& );				// 󥹥ȥ饯
	virtual  ~VDG60();						// ǥȥ饯
	
	BOOL Init();							// 
	BOOL LoadFont( char *, char * );		// VDGեɹ
	
	// ǥХID
	enum IDOut{ outB0H=0 };
	enum IDIn {};
	
	// ------------------------------------------
	BOOL DokoSave( cIni * );	// ɤǤSAVE
	BOOL DokoLoad( cIni * );	// ɤǤLOAD
	// ------------------------------------------
};


class VDG62 : public VDG6, public Device {
protected:
	BOOL Mk2CharMode;						// mk2 ɽ⡼ TRUE:饯 FALSE:եå
	BOOL Mk2GraphMode;						// mk2 եå TRUE:160*200 FALSE:320*200
	
	int Css1;								// Ȥ߹碌
	int Css2;
	int Css3;
	
	BYTE CrtCtrlPara;						// CRTȥͿѥ᡼
	
	void SetVramAddr( BYTE );				// VRAM ɥ쥹ڤؤ
	void CrtKill();							// CRT KILL
	void Vram2Screen();						// VRAM Ƥ ХåХåե
	
	void SetCss( BYTE );					// ȹ礻
	void SetCrtControler( BYTE );			// CRTȥ⡼
	
	BYTE GetFont2( WORD );					// Font2ǡ
	
	void Putc_M2( int, int, WORD );			// [N60] ⡼2 1ʸPUT
	void Putc_M21( int, int, WORD );		// [mk2] ⡼1 1ʸPUT
	void Mode_12();							// [N60] Mode 1,2 sub
	void Mode_34();							// [N60] Mode 3,4 sub
	void Mode2_1();							// [mk2] Mode 1,2 sub
	void Mode2_3();							// [mk2] Mode 3 sub
	void Mode2_4();							// [mk2] Mode 4 sub
	
	// ǥХ
	static const Descriptor descriptor;
	static const InFuncPtr  indef[];
	static const OutFuncPtr outdef[];
	const Descriptor* GetDesc() const { return &descriptor; }
	
	// I/Oؿ
	inline void OutB0H( int, BYTE data ){ SetVramAddr( data ); }
	inline void OutC0H( int, BYTE data ){ SetCss( data ); }
	inline void OutC1H( int, BYTE data ){ SetCrtControler( data ); }
	inline BYTE InC1H( int ){ return CrtCtrlPara; }
	
public:
	VDG62( VM6 *, const P6ID& );			// 󥹥ȥ饯
	virtual  ~VDG62();						// ǥȥ饯
	
	BOOL Init();							// 
	
	// ǥХID
	enum IDOut{ outB0H=0, outC0H, outC1H };
	enum IDIn {  inC1H=0 };
	
	// ------------------------------------------
	BOOL DokoSave( cIni * );	// ɤǤSAVE
	BOOL DokoLoad( cIni * );	// ɤǤLOAD
	// ------------------------------------------
};


#endif	// MC6847_H_INCLUDED
