#include <new>

#include "pc60.h"
#include "error.h"

#include "ini.h"

#include "ay8910.h"
#include "breakpoint.h"
#include "common.h"
#include "debug.h"
#include "disk.h"
#include "graph.h"
#include "intr.h"
#include "io.h"
#include "keyboard.h"
#include "mc6847.h"
#include "memory.h"
#include "osd.h"
#include "pd8049.h"
#include "pd8255.h"
#include "schedule.h"
#include "sound.h"
#include "status.h"
#include "tape.h"
#include "voice.h"
#include "z80.h"



////////////////////////////////////////////////////////////////
// 󥹥ȥ饯
////////////////////////////////////////////////////////////////
VM6::VM6( void )
{
	UDFPSCount = 0;		// FPSɽޥ󥿽
	FSkipCount = 0;		// ե졼ॹåץ
	
	io		= NULL;
	ios		= NULL;
	sche	= NULL;
	snd		= NULL;
	psg		= NULL;
	mem		= NULL;
	vdg		= NULL;
	graph	= NULL;
	intr	= NULL;
	cpu		= NULL;
	disk	= NULL;
	cmt		= NULL;
	cmts	= NULL;
	subcpu	= NULL;
	pio		= NULL;
	key		= NULL;
	voice   = NULL;
	
	staw    = NULL;
	
	UpDateFPSID	= NULL;
	
	#ifdef USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	bp      = NULL;
	regw	= NULL;
	memw	= NULL;
	monw	= NULL;
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
}

VM60::VM60( void ){}
VM62::VM62( void ){}
VM66::VM66( void ){}


////////////////////////////////////////////////////////////////
// ǥȥ饯
////////////////////////////////////////////////////////////////
VM6::~VM6( void )
{
	#ifdef USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	if( monw )   delete monw;
	if( memw )   delete memw;
	if( regw )   delete regw;
	if( bp )     delete bp;
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
	if( UpDateFPSID ) SDL_RemoveTimer( UpDateFPSID );
	
	if( staw )   delete staw;
	
	if( voice )  delete voice;
	if( key )    delete key;
	if( pio )    delete pio;
	if( subcpu ) delete subcpu;
	if( cmts )   delete cmts;
	if( cmt )    delete cmt;
	if( disk )   delete disk;
	if( cpu )    delete cpu;
	if( intr )   delete intr;
	if( graph )  delete graph;
	if( vdg )    delete vdg;
	if( mem )    delete mem;
	if( psg )    delete psg;
	if( snd )    delete snd;
	if( sche )   delete sche;
	if( ios )    delete ios;
	if( io )     delete io;
	
	// 󥽡ѥե˴
	JFont::CloseFont();
}

VM60::~VM60( void ){}
VM62::~VM62( void ){}
VM66::~VM66( void ){}



////////////////////////////////////////////////////////////////
// åɴؿ(С饤)
////////////////////////////////////////////////////////////////
void VM6::OnThread( void *inst )
{
	VM6 *p6;
	
	p6 = (VM6 *)inst;	// ʬȤΥ֥ȥݥ󥿼
	
	#ifdef USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	if( p6->cGlobal::MonDisp ){
	// ˥⡼
		while( !this->SThread::IsCancel() ){
			// ̹
			if( p6->sche->IsScreenUpdate() ) p6->ScreenUpdate();
			p6->sche->VWait();		// 
		}
	}else
	// ̾⡼
		if( bp->ExistBreakPoint() ){
			// ֥졼ݥȤ
			while( !this->SThread::IsCancel() ){
				p6->Emu();		// 1̿¹
				
				if( p6->sche->IsVSYNC() ){
					// ΡȻΥ쥹ݥ󥹤褯뤿
					// Ū˥٥Ȥ߾夲
					SDL_PumpEvents();
					p6->key->ScanMatrix();	// ޥȥꥯ
					
					// ɹ
					p6->SoundUpdate( 0 );
					// ̹
					if( p6->sche->IsScreenUpdate() ) p6->ScreenUpdate();
					p6->sche->VWait();		// 
				}
				
				// ֥졼ݥȥå
				if( bp->CheckBreakPoint( BPoint::BP_PC, cpu->GetPC(), 0, NULL ) || bp->IsReqBreak() ){
					this->SThread::Cancel();	// åɽλե饰ΩƤ
					bp->ResetBreak();
					SENDEVENT1( SDL_DEBUGMODEBP, cpu->GetPC() )
				}
			}
		}else
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	{	// ̾¹
		while( !this->SThread::IsCancel() ){
			// ΡȻΥ쥹ݥ󥹤褯뤿
			// Ū˥٥Ȥ߾夲
			SDL_PumpEvents();
			
			
			// ץ쥤
			if( REPLAY::GetStatus() == REP_REPLAY )
				REPLAY::ReplayReadFrame( p6->key->GetMatrix() );
			
			// ޥȥꥯ
			BOOL matchg = p6->key->ScanMatrix();
			
			// ץ쥤Ͽ
			if( REPLAY::GetStatus() == REP_RECORD )
				REPLAY::ReplayWriteFrame( p6->key->GetMatrix2(), matchg );
			
			
			p6->EmuVSYNC();			// 1ʬ¹
			
			// ӥǥץ?
			if( AVI6::IsAVI() ){
				// ӥǥץʤ餳AVI¸
				// ɹ
				p6->SoundUpdate( 0, AVI6::GetAudioBuffer() );
				// ̹
				BOOL update = p6->ScreenUpdate();
				// ̹Ƥ AVI1¸
				if( update ) AVI6::AVIWriteFrame();
			}else{
				// ӥǥץǤʤʤ̾ι
				// ɹ
				p6->SoundUpdate( 0 );
				// ̹
				// ̹ޤƤ̹
				// ΡȤλFPSѤʤ褦ˤ
				if( p6->sche->IsScreenUpdate() ) p6->ScreenUpdate();
			}
			p6->sche->VWait();		// 
		}
	}
}


////////////////////////////////////////////////////////////////
// Waitͭ?
////////////////////////////////////////////////////////////////
BOOL VM6::IsWaitEnable( void )
{
	return sche->GetWaitEnable() && (!cGlobal::TurboTAPE || (subcpu->GetCmtStatus() == CMTCLOSE));
}


////////////////////////////////////////////////////////////////
// 1̿¹
////////////////////////////////////////////////////////////////
int VM6::Emu( void )
{
	int state = cpu->Exec();	// CPU 1̿¹
	sche->Update( state );		// ٥ȹ
	
	return state;
}


////////////////////////////////////////////////////////////////
// 1ʬ¹
////////////////////////////////////////////////////////////////
int VM6::EmuVSYNC( void )
{
	int state = 0;
	
	// VSYNCȯޤǷ֤
	while( !sche->IsVSYNC() ){
		int st = cpu->Exec();	// CPU 1̿¹
		sche->Update( st );		// ٥ȹ
		state += st;
	}
	
	return state;
}


#ifdef USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
////////////////////////////////////////////////////////////////
// ꥹơȿ¹
////////////////////////////////////////////////////////////////
void VM6::Exec( int st )
{
	int State = st;
	
	while( State > 0 ) State -= Emu();
}


////////////////////////////////////////////////////////////////
// եå(M1)
////////////////////////////////////////////////////////////////
BYTE VM6::Fetch( WORD addr, int *m1wait )
{
	BYTE data = mem->Fetch( addr, m1wait );
	
	#ifdef USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	// ֥졼ݥȥå
	if( bp->CheckBreakPoint( BPoint::BP_READ, addr, data, NULL ) ){
		PRINTD( MEM_LOG, " -> Break!" );
	}
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	PRINTD( MEM_LOG, "\n" );
	
	return data;
}


////////////////////////////////////////////////////////////////
// ꡼
////////////////////////////////////////////////////////////////
BYTE VM6::Read( WORD addr, int *wcnt )
{
	BYTE data = mem->Read( addr, wcnt );
	
	#ifdef USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	// ֥졼ݥȥå
	if( bp->CheckBreakPoint( BPoint::BP_READ, addr, data, NULL ) ){
		PRINTD( MEM_LOG, " -> Break!" );
	}
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	PRINTD( MEM_LOG, "\n" );
	
	return data;
}


////////////////////////////////////////////////////////////////
// 饤
////////////////////////////////////////////////////////////////
void VM6::Write( WORD addr, BYTE data, int *wcnt )
{
	mem->Write( addr, data, wcnt );
	
	#ifdef USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	// ֥졼ݥȥå
	if( bp->CheckBreakPoint( BPoint::BP_WRITE, addr, data, NULL ) ){
		PRINTD( MEM_LOG, " -> Break!" );
	}
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	PRINTD( MEM_LOG, "\n" );
}


////////////////////////////////////////////////////////////////
// INؿ
////////////////////////////////////////////////////////////////
BYTE VM6::In( int port )
{
	BYTE data = io->In( port );
	
	#ifdef USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	// ֥졼ݥȥå
	if( bp->CheckBreakPoint( BPoint::BP_IN, port, data, NULL ) ){
		PRINTD( IO_LOG, " -> Break!" );
	}
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	PRINTD( IO_LOG, "\n" );
	
	return data;
}


////////////////////////////////////////////////////////////////
// OUTؿ
////////////////////////////////////////////////////////////////
void VM6::Out( int port, BYTE data )
{
	io->Out( port, data );
	
	#ifdef USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	// ֥졼ݥȥå
	if( bp->CheckBreakPoint( BPoint::BP_OUT, port, data, NULL ) ){
		PRINTD( IO_LOG, " -> Break!" );
	}
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	PRINTD( IO_LOG, "\n" );
}


////////////////////////////////////////////////////////////////
// ˥⡼ؤ
////////////////////////////////////////////////////////////////
BOOL VM6::ToggleMonitor( void )
{
	// VM
	Stop();
	
	// ˥ɥɽڴ
	cGlobal::MonDisp = cGlobal::MonDisp ? FALSE : TRUE;
	
	// ˥⡼ɤʤUnicodeͭ
	SDL_EnableUNICODE( cGlobal::MonDisp ? 1 : 0 );
	
	// ֥졼ݥȤξ򥯥ꥢ
	bp->ClearStatus();
	
	// ꡼󥵥ѹ
	graph->ResizeScreen();
	
	// VMƳ
	Start();
	
	return cGlobal::MonDisp;
}
#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //


////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////
BOOL VM60::Init( void )
{
	// 顼å
	Error::SetError( Error::InitFailed );
	
	// Ƽ索֥ȳ
	io     = new IO6;											// I/O(Z80)
	ios    = new IO6;											// I/O(SUB CPU)
	intr   = new INT60( this, DEV_ID('I', 'N', 'T', 'R') );		// 
	sche   = new SCH6 ( this, DEV_ID('S', 'C', 'H', 'E') );		// 塼
	snd    = new SND6;											// 
	cpu    = new CPU6 ( this, DEV_ID('C', 'P', 'U', '1') );		// CPU
	subcpu = new SUB6 ( this, DEV_ID('8', '0', '4', '9') );		// SUB CPU
	mem    = new MEM60( cGlobal::UseExtRam );					// 
	vdg    = new VDG60( this, DEV_ID('V', 'D', 'G', '1') );		// VDG
	graph  = new DSP6 ( this, DEV_ID('D', 'I', 'S', 'P') );		// 
	psg    = new PSG6 ( this, DEV_ID('P', 'S', 'G', '1') );		// PSG
	pio    = new PIO6 ( this, DEV_ID('8', '2', '5', '5') );		// 8255
	key    = new KEY60( this, DEV_ID('K', 'E', 'Y', 'B') );		// 
	cmt    = new CMTL ( this, DEV_ID('T', 'A', 'P', 'E') );		// CMT(LOAD)
	cmts   = new CMTS ( this, DEV_ID('S', 'A', 'V', 'E') );		// CMT(SAVE)
	disk   = new DSK60( this, DEV_ID('D', 'I', 'S', 'K'), cGlobal::FddNum );	// DISK
	staw   = new cWndStat( this, DEV_ID('S', 'T', 'A', 'W') );	// ơС
	
	if( !io    || !ios || !intr || !sche || !snd  || !cpu  || !subcpu || !mem  || !vdg ||
		!graph || !psg || !pio  || !key  || !cmt  || !cmts || !disk   || !staw )
			return FALSE;
	
	
	// Ƽ索֥ȽȥǥХ³
	
	// ʬ
	if( !VM6::InitCommon() ) return FALSE;
	
	//  -----
	const static IOBus::Connector c_intr[] = {
		{ 0xb0, IOBus::portout, INT60::outB0H },
		{ 0xb1, IOBus::portout, INT60::outB0H },	// ᡼
		{ 0xb2, IOBus::portout, INT60::outB0H },	// ᡼
		{ 0xb3, IOBus::portout, INT60::outB0H },	// ᡼
		{ 0xb4, IOBus::portout, INT60::outB0H },	// ᡼
		{ 0xb5, IOBus::portout, INT60::outB0H },	// ᡼
		{ 0xb6, IOBus::portout, INT60::outB0H },	// ᡼
		{ 0xb7, IOBus::portout, INT60::outB0H },	// ᡼
		{ 0xb8, IOBus::portout, INT60::outB0H },	// ᡼
		{ 0xb9, IOBus::portout, INT60::outB0H },	// ᡼
		{ 0xba, IOBus::portout, INT60::outB0H },	// ᡼
		{ 0xbb, IOBus::portout, INT60::outB0H },	// ᡼
		{ 0xbc, IOBus::portout, INT60::outB0H },	// ᡼
		{ 0xbd, IOBus::portout, INT60::outB0H },	// ᡼
		{ 0xbe, IOBus::portout, INT60::outB0H },	// ᡼
		{ 0xbf, IOBus::portout, INT60::outB0H },	// ᡼
		{ 0, 0, 0 }	};
	if( !io->Connect( (INT60*)intr, c_intr ) ) return FALSE;
	
	// VDG -----
	const static IOBus::Connector c_vdg[] = {
		{ 0xb0, IOBus::portout, VDG60::outB0H },
		{ 0xb1, IOBus::portout, VDG60::outB0H },	// ᡼
		{ 0xb2, IOBus::portout, VDG60::outB0H },	// ᡼
		{ 0xb3, IOBus::portout, VDG60::outB0H },	// ᡼
		{ 0xb4, IOBus::portout, VDG60::outB0H },	// ᡼
		{ 0xb5, IOBus::portout, VDG60::outB0H },	// ᡼
		{ 0xb6, IOBus::portout, VDG60::outB0H },	// ᡼
		{ 0xb7, IOBus::portout, VDG60::outB0H },	// ᡼
		{ 0xb8, IOBus::portout, VDG60::outB0H },	// ᡼
		{ 0xb9, IOBus::portout, VDG60::outB0H },	// ᡼
		{ 0xba, IOBus::portout, VDG60::outB0H },	// ᡼
		{ 0xbb, IOBus::portout, VDG60::outB0H },	// ᡼
		{ 0xbc, IOBus::portout, VDG60::outB0H },	// ᡼
		{ 0xbd, IOBus::portout, VDG60::outB0H },	// ᡼
		{ 0xbe, IOBus::portout, VDG60::outB0H },	// ᡼
		{ 0xbf, IOBus::portout, VDG60::outB0H },	// ᡼
		{ 0, 0, 0 } };
	if( !io->Connect( (VDG60*)vdg, c_vdg ) ) return FALSE;
	// VDGեɹ
	vdg->LoadFont( cGlobal::RomPath, FONTV_FILE );
	
	
	// PSG -----
	const static IOBus::Connector c_psg[] = {
		{ 0xa0, IOBus::portout, PSG6::outA0H },
		{ 0xa1, IOBus::portout, PSG6::outA1H },
		{ 0xa3, IOBus::portout, PSG6::outA3H },
		{ 0xa4, IOBus::portout, PSG6::outA0H },	// ᡼
		{ 0xa5, IOBus::portout, PSG6::outA1H },	// ᡼
		{ 0xa7, IOBus::portout, PSG6::outA3H },	// ᡼
		{ 0xa8, IOBus::portout, PSG6::outA0H },	// ᡼
		{ 0xa9, IOBus::portout, PSG6::outA1H },	// ᡼
		{ 0xab, IOBus::portout, PSG6::outA3H },	// ᡼
		{ 0xac, IOBus::portout, PSG6::outA0H },	// ᡼
		{ 0xad, IOBus::portout, PSG6::outA1H },	// ᡼
		{ 0xaf, IOBus::portout, PSG6::outA3H },	// ᡼
		{ 0xa2, IOBus::portin,  PSG6::inA2H },
		{ 0xa6, IOBus::portin,  PSG6::inA2H },	// ᡼
		{ 0xaa, IOBus::portin,  PSG6::inA2H },	// ᡼
		{ 0xae, IOBus::portin,  PSG6::inA2H },	// ᡼
		{ 0, 0, 0 }	};
	if( !io->Connect( psg, c_psg ) ) return FALSE;
	
	// 8255(Z80¦) -----
	const static IOBus::Connector c_8255[] = {
		{ 0x90, IOBus::portout, PIO6::out90H },
		{ 0x91, IOBus::portout, PIO6::out91H },
		{ 0x92, IOBus::portout, PIO6::out92H },
		{ 0x93, IOBus::portout, PIO6::out93H },
		{ 0x94, IOBus::portout, PIO6::out90H },	// ᡼
		{ 0x95, IOBus::portout, PIO6::out91H },	// ᡼
		{ 0x96, IOBus::portout, PIO6::out92H },	// ᡼
		{ 0x97, IOBus::portout, PIO6::out93H },	// ᡼
		{ 0x98, IOBus::portout, PIO6::out90H },	// ᡼
		{ 0x99, IOBus::portout, PIO6::out91H },	// ᡼
		{ 0x9a, IOBus::portout, PIO6::out92H },	// ᡼
		{ 0x9b, IOBus::portout, PIO6::out93H },	// ᡼
		{ 0x9c, IOBus::portout, PIO6::out90H },	// ᡼
		{ 0x9d, IOBus::portout, PIO6::out91H },	// ᡼
		{ 0x9e, IOBus::portout, PIO6::out92H },	// ᡼
		{ 0x9f, IOBus::portout, PIO6::out93H },	// ᡼
		{ 0x90, IOBus::portin,  PIO6::in90H },
		{ 0x92, IOBus::portin,  PIO6::in92H },
		{ 0x93, IOBus::portin,  PIO6::in93H },
		{ 0x94, IOBus::portin,  PIO6::in90H },	// ᡼
		{ 0x96, IOBus::portin,  PIO6::in92H },	// ᡼
		{ 0x97, IOBus::portin,  PIO6::in93H },	// ᡼
		{ 0x98, IOBus::portin,  PIO6::in90H },	// ᡼
		{ 0x9a, IOBus::portin,  PIO6::in92H },	// ᡼
		{ 0x9b, IOBus::portin,  PIO6::in93H },	// ᡼
		{ 0x9c, IOBus::portin,  PIO6::in90H },	// ᡼
		{ 0x9e, IOBus::portin,  PIO6::in92H },	// ᡼
		{ 0x9f, IOBus::portin,  PIO6::in93H },	// ᡼
		{ 0, 0, 0 }	};
	if( !io->Connect( pio, c_8255 ) ) return FALSE;
	
	// 8255(SUB CPU¦) -----
	const static IOBus::Connector c_8255s[] = {
		{ IO8049_BUS, IOBus::portout, PIO6::outPBH },
		{ IO8049_BUS, IOBus::portin,  PIO6::inPBH  },
		{ IO8049_T0,  IOBus::portin,  PIO6::inIBF  },
		{ IO8049_INT, IOBus::portin,  PIO6::inOBF  },
		{ 0, 0, 0 }	};
	if( !ios->Connect( pio, c_8255s ) ) return FALSE;
	
	// DISK -----
	if( disk->GetDrives() ){
		const static IOBus::Connector c_disk[] = {
			{ 0xd1, IOBus::portout, DSK60::outD1H },
			{ 0xd2, IOBus::portout, DSK60::outD2H },
			{ 0xd3, IOBus::portout, DSK60::outD3H },
			{ 0xd5, IOBus::portout, DSK60::outD1H },	// ᡼
			{ 0xd6, IOBus::portout, DSK60::outD2H },	// ᡼
			{ 0xd7, IOBus::portout, DSK60::outD3H },	// ᡼
			{ 0xd9, IOBus::portout, DSK60::outD1H },	// ᡼
			{ 0xda, IOBus::portout, DSK60::outD2H },	// ᡼
			{ 0xdb, IOBus::portout, DSK60::outD3H },	// ᡼
			{ 0xdd, IOBus::portout, DSK60::outD1H },	// ᡼
			{ 0xde, IOBus::portout, DSK60::outD2H },	// ᡼
			{ 0xdf, IOBus::portout, DSK60::outD3H },	// ᡼
			{ 0xd0, IOBus::portin,  DSK60::inD0H },
			{ 0xd1, IOBus::portin,  DSK60::inD1H },
			{ 0xd2, IOBus::portin,  DSK60::inD2H },
			{ 0xd3, IOBus::portin,  DSK60::inD3H },
			{ 0xd4, IOBus::portin,  DSK60::inD0H },		// ᡼
			{ 0xd5, IOBus::portin,  DSK60::inD1H },		// ᡼
			{ 0xd6, IOBus::portin,  DSK60::inD2H },		// ᡼
			{ 0xd7, IOBus::portin,  DSK60::inD3H },		// ᡼
			{ 0xd8, IOBus::portin,  DSK60::inD0H },		// ᡼
			{ 0xd9, IOBus::portin,  DSK60::inD1H },		// ᡼
			{ 0xda, IOBus::portin,  DSK60::inD2H },		// ᡼
			{ 0xdb, IOBus::portin,  DSK60::inD3H },		// ᡼
			{ 0xdc, IOBus::portin,  DSK60::inD0H },		// ᡼
			{ 0xdd, IOBus::portin,  DSK60::inD1H },		// ᡼
			{ 0xde, IOBus::portin,  DSK60::inD2H },		// ᡼
			{ 0xdf, IOBus::portin,  DSK60::inD3H },		// ᡼
			{ 0, 0, 0 }	};
		if( !io->Connect( (DSK60*)disk, c_disk ) ) return FALSE;
		if( !disk->Init() ) return FALSE;
		// ɥ饤1DISK
		if( *cGlobal::DiskFile[0] ) DiskInsert( 0, cGlobal::DiskFile[0] );
	}
	
	// CMT(LOAD) -----
	const static IOBus::Connector c_cmt[] = {
		{ 0xb0, IOBus::portout, CMTL::outB0H },
		{ 0xb1, IOBus::portout, CMTL::outB0H },	// ᡼
		{ 0xb2, IOBus::portout, CMTL::outB0H },	// ᡼
		{ 0xb3, IOBus::portout, CMTL::outB0H },	// ᡼
		{ 0xb4, IOBus::portout, CMTL::outB0H },	// ᡼
		{ 0xb5, IOBus::portout, CMTL::outB0H },	// ᡼
		{ 0xb6, IOBus::portout, CMTL::outB0H },	// ᡼
		{ 0xb7, IOBus::portout, CMTL::outB0H },	// ᡼
		{ 0xb8, IOBus::portout, CMTL::outB0H },	// ᡼
		{ 0xb9, IOBus::portout, CMTL::outB0H },	// ᡼
		{ 0xba, IOBus::portout, CMTL::outB0H },	// ᡼
		{ 0xbb, IOBus::portout, CMTL::outB0H },	// ᡼
		{ 0xbc, IOBus::portout, CMTL::outB0H },	// ᡼
		{ 0xbd, IOBus::portout, CMTL::outB0H },	// ᡼
		{ 0xbe, IOBus::portout, CMTL::outB0H },	// ᡼
		{ 0xbf, IOBus::portout, CMTL::outB0H },	// ᡼
		{ 0, 0, 0 }	};
	if( !io->Connect( cmt, c_cmt ) ) return FALSE;
	
	Reset();
	
	// ꡼󥵥ѹ
	graph->ResizeScreen();
	
	// 顼ʤ
	Error::SetError( Error::NoError );
	
	return TRUE;
}

BOOL VM62::Init( void )
{
	// 顼å
	Error::SetError( Error::InitFailed );
	
	// Ƽ索֥ȳ
	io     = new IO6;											// I/O(Z80)
	ios    = new IO6;											// I/O(SUB CPU)
	intr   = new INT62( this, DEV_ID('I', 'N', 'T', 'R') );		// 
	sche   = new SCH6 ( this, DEV_ID('S', 'C', 'H', 'E') );		// 塼
	snd    = new SND6;											// 
	cpu    = new CPU6 ( this, DEV_ID('C', 'P', 'U', '1') );		// CPU
	subcpu = new SUB6 ( this, DEV_ID('8', '0', '4', '9') );		// SUB CPU
	mem    = new MEM62( DEV_ID('M', 'E', 'M', '1') );			// 
	vdg    = new VDG62( this, DEV_ID('V', 'D', 'G', '2') );		// VDG
	graph  = new DSP6 ( this, DEV_ID('D', 'I', 'S', 'P') );		// 
	psg    = new PSG6 ( this, DEV_ID('P', 'S', 'G', '1') );		// PSG
	pio    = new PIO6 ( this, DEV_ID('8', '2', '5', '5') );		// 8255
	key    = new KEY6 ( this, DEV_ID('K', 'E', 'Y', 'B') );		// 
	voice  = new VCE6 ( this, DEV_ID('V', 'O', 'I', 'C') );		// 
	cmt    = new CMTL ( this, DEV_ID('T', 'A', 'P', 'E') );		// CMT(LOAD)
	cmts   = new CMTS ( this, DEV_ID('S', 'A', 'V', 'E') );		// CMT(SAVE)
	disk   = new DSK60( this, DEV_ID('D', 'I', 'S', 'K'), cGlobal::FddNum );	// DISK
	staw   = new cWndStat( this, DEV_ID('S', 'T', 'A', 'W') );	// ơС
	
	if( !io    || !ios || !intr || !sche || !snd   || !cpu || !subcpu || !mem  || !vdg  ||
		!graph || !psg || !pio  || !key  || !voice || !cmt || !cmts   || !disk || !staw )
			return FALSE;
	
	
	// Ƽ索֥ȽȥǥХ³
	
	// ʬ
	if( !VM6::InitCommon() ) return FALSE;
	
	//  -----
	const static IOBus::Connector c_intr[] = {
		{ 0xb0, IOBus::portout, INT62::outB0H },
		{ 0xf3, IOBus::portout, INT62::outF3H },
		{ 0xf4, IOBus::portout, INT62::outF4H },
		{ 0xf5, IOBus::portout, INT62::outF5H },
		{ 0xf6, IOBus::portout, INT62::outF6H },
		{ 0xf7, IOBus::portout, INT62::outF7H },
		{ 0xf3, IOBus::portin,  INT62::inF3H },
		{ 0xf4, IOBus::portin,  INT62::inF4H },
		{ 0xf5, IOBus::portin,  INT62::inF5H },
		{ 0xf6, IOBus::portin,  INT62::inF6H },
		{ 0xf7, IOBus::portin,  INT62::inF7H },
		{ 0, 0, 0 }	};
	if( !io->Connect( (INT62*)intr, c_intr ) ) return FALSE;
	
	//  -----
	const static IOBus::Connector c_memory[] = {
		{ 0xc1, IOBus::portout, MEM62::outC1H },
		{ 0xc2, IOBus::portout, MEM62::outC2H },
		{ 0xc3, IOBus::portout, MEM62::outC3H },
		{ 0xf0, IOBus::portout, MEM62::outF0H },
		{ 0xf1, IOBus::portout, MEM62::outF1H },
		{ 0xf2, IOBus::portout, MEM62::outF2H },
		{ 0xf3, IOBus::portout, MEM62::outF3H },
		{ 0xf0, IOBus::portin,  MEM62::inF0H },
		{ 0xf1, IOBus::portin,  MEM62::inF1H },
		{ 0xf2, IOBus::portin,  MEM62::inF2H },
		{ 0xf3, IOBus::portin,  MEM62::inF3H },
		{ 0, 0, 0 }	};
	if( !io->Connect( (MEM62*)mem, c_memory ) ) return FALSE;
	
	// VDG -----
	const static IOBus::Connector c_vdg[] = {
		{ 0xb0, IOBus::portout, VDG62::outB0H },
		{ 0xc0, IOBus::portout, VDG62::outC0H },
		{ 0xc1, IOBus::portout, VDG62::outC1H },
		{ 0xc1, IOBus::portin,  VDG62::inC1H },
		{ 0, 0, 0 } };
	if( !io->Connect( (VDG62*)vdg, c_vdg ) ) return FALSE;
	
	// PSG -----
	const static IOBus::Connector c_psg[] = {
		{ 0xa0, IOBus::portout, PSG6::outA0H },
		{ 0xa1, IOBus::portout, PSG6::outA1H },
		{ 0xa3, IOBus::portout, PSG6::outA3H },
		{ 0xa2, IOBus::portin,  PSG6::inA2H },
		{ 0, 0, 0 }	};
	if( !io->Connect( psg, c_psg ) ) return FALSE;
	
	// 8255(Z80¦) -----
	const static IOBus::Connector c_8255[] = {
		{ 0x90, IOBus::portout, PIO6::out90H },
		{ 0x91, IOBus::portout, PIO6::out91H },
		{ 0x92, IOBus::portout, PIO6::out92H },
		{ 0x93, IOBus::portout, PIO6::out93H },
		{ 0x90, IOBus::portin,  PIO6::in90H },
		{ 0x92, IOBus::portin,  PIO6::in92H },
		{ 0x93, IOBus::portin,  PIO6::in93H },
		{ 0, 0, 0 }	};
	if( !io->Connect( pio, c_8255 ) ) return FALSE;
	
	// 8255(SUB CPU¦) -----
	const static IOBus::Connector c_8255s[] = {
		{ IO8049_BUS, IOBus::portout, PIO6::outPBH },
		{ IO8049_BUS, IOBus::portin,  PIO6::inPBH  },
		{ IO8049_T0,  IOBus::portin,  PIO6::inIBF  },
		{ IO8049_INT, IOBus::portin,  PIO6::inOBF  },
		{ 0, 0, 0 }	};
	if( !ios->Connect( pio, c_8255s ) ) return FALSE;
	
	//  -----
	const static IOBus::Connector c_voice[] = {
		{ 0xe0, IOBus::portout, VCE6::outE0H },
		{ 0xe2, IOBus::portout, VCE6::outE2H },
		{ 0xe3, IOBus::portout, VCE6::outE3H },
		{ 0xe4, IOBus::portout, VCE6::outE0H },	// ᡼
		{ 0xe6, IOBus::portout, VCE6::outE2H },	// ᡼
		{ 0xe7, IOBus::portout, VCE6::outE3H },	// ᡼
		{ 0xe8, IOBus::portout, VCE6::outE0H },	// ᡼
		{ 0xea, IOBus::portout, VCE6::outE2H },	// ᡼
		{ 0xeb, IOBus::portout, VCE6::outE3H },	// ᡼
		{ 0xec, IOBus::portout, VCE6::outE0H },	// ᡼
		{ 0xee, IOBus::portout, VCE6::outE2H },	// ᡼
		{ 0xef, IOBus::portout, VCE6::outE3H },	// ᡼
		{ 0xe0, IOBus::portin,  VCE6::inE0H },
		{ 0xe2, IOBus::portin,  VCE6::inE2H },
		{ 0xe3, IOBus::portin,  VCE6::inE3H },
		{ 0xe4, IOBus::portin,  VCE6::inE0H },	// ᡼
		{ 0xe6, IOBus::portin,  VCE6::inE2H },	// ᡼
		{ 0xe7, IOBus::portin,  VCE6::inE3H },	// ᡼
		{ 0xe8, IOBus::portin,  VCE6::inE0H },	// ᡼
		{ 0xea, IOBus::portin,  VCE6::inE2H },	// ᡼
		{ 0xeb, IOBus::portin,  VCE6::inE3H },	// ᡼
		{ 0xec, IOBus::portin,  VCE6::inE0H },	// ᡼
		{ 0xee, IOBus::portin,  VCE6::inE2H },	// ᡼
		{ 0xef, IOBus::portin,  VCE6::inE3H },	// ᡼
		{ 0, 0, 0 }	};
	if( !io->Connect( voice, c_voice ) ) return FALSE;
	if( !voice->Init( cGlobal::WavePath ) ) return FALSE;
	voice->SetVolume( cGlobal::VoiceVol );
	
	// DISK -----
	if( disk->GetDrives() ){
		const static IOBus::Connector c_disk[] = {
			{ 0xd1, IOBus::portout, DSK60::outD1H },
			{ 0xd2, IOBus::portout, DSK60::outD2H },
			{ 0xd3, IOBus::portout, DSK60::outD3H },
			{ 0xd5, IOBus::portout, DSK60::outD1H },	// ᡼
			{ 0xd6, IOBus::portout, DSK60::outD2H },	// ᡼
			{ 0xd7, IOBus::portout, DSK60::outD3H },	// ᡼
			{ 0xd9, IOBus::portout, DSK60::outD1H },	// ᡼
			{ 0xda, IOBus::portout, DSK60::outD2H },	// ᡼
			{ 0xdb, IOBus::portout, DSK60::outD3H },	// ᡼
			{ 0xdd, IOBus::portout, DSK60::outD1H },	// ᡼
			{ 0xde, IOBus::portout, DSK60::outD2H },	// ᡼
			{ 0xdf, IOBus::portout, DSK60::outD3H },	// ᡼
			{ 0xd0, IOBus::portin,  DSK60::inD0H },
			{ 0xd1, IOBus::portin,  DSK60::inD1H },
			{ 0xd2, IOBus::portin,  DSK60::inD2H },
			{ 0xd3, IOBus::portin,  DSK60::inD3H },
			{ 0xd4, IOBus::portin,  DSK60::inD0H },		// ᡼
			{ 0xd5, IOBus::portin,  DSK60::inD1H },		// ᡼
			{ 0xd6, IOBus::portin,  DSK60::inD2H },		// ᡼
			{ 0xd7, IOBus::portin,  DSK60::inD3H },		// ᡼
			{ 0xd8, IOBus::portin,  DSK60::inD0H },		// ᡼
			{ 0xd9, IOBus::portin,  DSK60::inD1H },		// ᡼
			{ 0xda, IOBus::portin,  DSK60::inD2H },		// ᡼
			{ 0xdb, IOBus::portin,  DSK60::inD3H },		// ᡼
			{ 0xdc, IOBus::portin,  DSK60::inD0H },		// ᡼
			{ 0xdd, IOBus::portin,  DSK60::inD1H },		// ᡼
			{ 0xde, IOBus::portin,  DSK60::inD2H },		// ᡼
			{ 0xdf, IOBus::portin,  DSK60::inD3H },		// ᡼
			{ 0, 0, 0 }	};
		if( !io->Connect( (DSK60*)disk, c_disk ) ) return FALSE;
		if( !disk->Init() ) return FALSE;
		// ɥ饤1DISK
		if( *cGlobal::DiskFile[0] ) DiskInsert( 0, cGlobal::DiskFile[0] );
	}
	
	// CMT(LOAD) -----
	const static IOBus::Connector c_cmt[] = {
		{ 0xb0, IOBus::portout, CMTL::outB0H },
		{ 0, 0, 0 }	};
	if( !io->Connect( cmt, c_cmt ) ) return FALSE;
	
	Reset();
	
	// ꡼󥵥ѹ
	graph->ResizeScreen();
	
	// 顼ʤ
	Error::SetError( Error::NoError );
	
	return TRUE;
}

BOOL VM66::Init( void )
{
	// 顼å
	Error::SetError( Error::InitFailed );
	
	// Ƽ索֥ȳ
	io     = new IO6;											// I/O(Z80)
	ios    = new IO6;											// I/O(SUB CPU)
	intr   = new INT62( this, DEV_ID('I', 'N', 'T', 'R') );		// 
	sche   = new SCH6 ( this, DEV_ID('S', 'C', 'H', 'E') );		// 塼
	snd    = new SND6;											// 
	cpu    = new CPU6 ( this, DEV_ID('C', 'P', 'U', '1') );		// CPU
	subcpu = new SUB6 ( this, DEV_ID('8', '0', '4', '9') );		// SUB CPU
	mem    = new MEM66( DEV_ID('M', 'E', 'M', '1') );			// 
	vdg    = new VDG62( this, DEV_ID('V', 'D', 'G', '2') );		// VDG
	graph  = new DSP6 ( this, DEV_ID('D', 'I', 'S', 'P') );		// 
	psg    = new PSG6 ( this, DEV_ID('P', 'S', 'G', '1') );		// PSG
	pio    = new PIO6 ( this, DEV_ID('8', '2', '5', '5') );		// 8255
	key    = new KEY6 ( this, DEV_ID('K', 'E', 'Y', 'B') );		// 
	voice  = new VCE6 ( this, DEV_ID('V', 'O', 'I', 'C') );		// 
	cmt    = new CMTL ( this, DEV_ID('T', 'A', 'P', 'E') );		// CMT(LOAD)
	cmts   = new CMTS ( this, DEV_ID('S', 'A', 'V', 'E') );		// CMT(SAVE)
	disk   = new DSK66( this, DEV_ID('D', 'I', 'S', 'K'), cGlobal::FddNum );	// DISK
	staw   = new cWndStat( this, DEV_ID('S', 'T', 'A', 'W') );	// ơС
	
	if( !io    || !ios || !intr || !sche || !snd   || !cpu || !subcpu || !mem  || !vdg  ||
		!graph || !psg || !pio  || !key  || !voice || !cmt || !cmts   || !disk || !staw )
			return FALSE;
	
	
	// Ƽ索֥ȽȥǥХ³
	
	// ʬ
	if( !VM6::InitCommon() ) return FALSE;
	
	//  -----
	const static IOBus::Connector c_intr[] = {
		{ 0xb0, IOBus::portout, INT62::outB0H },
		{ 0xf3, IOBus::portout, INT62::outF3H },
		{ 0xf4, IOBus::portout, INT62::outF4H },
		{ 0xf5, IOBus::portout, INT62::outF5H },
		{ 0xf6, IOBus::portout, INT62::outF6H },
		{ 0xf7, IOBus::portout, INT62::outF7H },
		{ 0xf3, IOBus::portin,  INT62::inF3H },
		{ 0xf4, IOBus::portin,  INT62::inF4H },
		{ 0xf5, IOBus::portin,  INT62::inF5H },
		{ 0xf6, IOBus::portin,  INT62::inF6H },
		{ 0xf7, IOBus::portin,  INT62::inF7H },
		{ 0, 0, 0 }	};
	if( !io->Connect( (INT62*)intr, c_intr ) ) return FALSE;
	
	//  -----
	const static IOBus::Connector c_memory[] = {
		{ 0xc1, IOBus::portout, MEM62::outC1H },
		{ 0xc2, IOBus::portout, MEM62::outC2H },
		{ 0xc3, IOBus::portout, MEM62::outC3H },
		{ 0xf0, IOBus::portout, MEM62::outF0H },
		{ 0xf1, IOBus::portout, MEM62::outF1H },
		{ 0xf2, IOBus::portout, MEM62::outF2H },
		{ 0xf3, IOBus::portout, MEM62::outF3H },
		{ 0xf0, IOBus::portin,  MEM62::inF0H },
		{ 0xf1, IOBus::portin,  MEM62::inF1H },
		{ 0xf2, IOBus::portin,  MEM62::inF2H },
		{ 0xf3, IOBus::portin,  MEM62::inF3H },
		{ 0, 0, 0 }	};
	if( !io->Connect( (MEM66*)mem, c_memory ) ) return FALSE;
	
	// VDG -----
	const static IOBus::Connector c_vdg[] = {
		{ 0xb0, IOBus::portout, VDG62::outB0H },
		{ 0xc0, IOBus::portout, VDG62::outC0H },
		{ 0xc1, IOBus::portout, VDG62::outC1H },
		{ 0xc1, IOBus::portin,  VDG62::inC1H },
		{ 0, 0, 0 } };
	if( !io->Connect( (VDG62*)vdg, c_vdg ) ) return FALSE;
	
	// PSG -----
	const static IOBus::Connector c_psg[] = {
		{ 0xa0, IOBus::portout, PSG6::outA0H },
		{ 0xa1, IOBus::portout, PSG6::outA1H },
		{ 0xa3, IOBus::portout, PSG6::outA3H },
		{ 0xa2, IOBus::portin,  PSG6::inA2H },
		{ 0, 0, 0 }	};
	if( !io->Connect( psg, c_psg ) ) return FALSE;
	
	// 8255(Z80¦) -----
	const static IOBus::Connector c_8255[] = {
		{ 0x90, IOBus::portout, PIO6::out90H },
		{ 0x91, IOBus::portout, PIO6::out91H },
		{ 0x92, IOBus::portout, PIO6::out92H },
		{ 0x93, IOBus::portout, PIO6::out93H },
		{ 0x90, IOBus::portin,  PIO6::in90H },
		{ 0x92, IOBus::portin,  PIO6::in92H },
		{ 0x93, IOBus::portin,  PIO6::in93H },
		{ 0, 0, 0 }	};
	if( !io->Connect( pio, c_8255 ) ) return FALSE;
	
	// 8255(SUB CPU¦) -----
	const static IOBus::Connector c_8255s[] = {
		{ IO8049_BUS, IOBus::portout, PIO6::outPBH },
		{ IO8049_BUS, IOBus::portin,  PIO6::inPBH  },
		{ IO8049_T0,  IOBus::portin,  PIO6::inIBF  },
		{ IO8049_INT, IOBus::portin,  PIO6::inOBF  },
		{ 0, 0, 0 }	};
	if( !ios->Connect( pio, c_8255s ) ) return FALSE;
	
	//  -----
	const static IOBus::Connector c_voice[] = {
		{ 0xe0, IOBus::portout, VCE6::outE0H },
		{ 0xe2, IOBus::portout, VCE6::outE2H },
		{ 0xe3, IOBus::portout, VCE6::outE3H },
		{ 0xe4, IOBus::portout, VCE6::outE0H },	// ᡼
		{ 0xe6, IOBus::portout, VCE6::outE2H },	// ᡼
		{ 0xe7, IOBus::portout, VCE6::outE3H },	// ᡼
		{ 0xe8, IOBus::portout, VCE6::outE0H },	// ᡼
		{ 0xea, IOBus::portout, VCE6::outE2H },	// ᡼
		{ 0xeb, IOBus::portout, VCE6::outE3H },	// ᡼
		{ 0xec, IOBus::portout, VCE6::outE0H },	// ᡼
		{ 0xee, IOBus::portout, VCE6::outE2H },	// ᡼
		{ 0xef, IOBus::portout, VCE6::outE3H },	// ᡼
		{ 0xe0, IOBus::portin,  VCE6::inE0H },
		{ 0xe2, IOBus::portin,  VCE6::inE2H },
		{ 0xe3, IOBus::portin,  VCE6::inE3H },
		{ 0xe4, IOBus::portin,  VCE6::inE0H },	// ᡼
		{ 0xe6, IOBus::portin,  VCE6::inE2H },	// ᡼
		{ 0xe7, IOBus::portin,  VCE6::inE3H },	// ᡼
		{ 0xe8, IOBus::portin,  VCE6::inE0H },	// ᡼
		{ 0xea, IOBus::portin,  VCE6::inE2H },	// ᡼
		{ 0xeb, IOBus::portin,  VCE6::inE3H },	// ᡼
		{ 0xec, IOBus::portin,  VCE6::inE0H },	// ᡼
		{ 0xee, IOBus::portin,  VCE6::inE2H },	// ᡼
		{ 0xef, IOBus::portin,  VCE6::inE3H },	// ᡼
		{ 0, 0, 0 }	};
	if( !io->Connect( voice, c_voice ) ) return FALSE;
	if( !voice->Init( cGlobal::WavePath ) ) return FALSE;
	voice->SetVolume( cGlobal::VoiceVol );
	
	// DISK -----
	const static IOBus::Connector c_disk[] = {
		{ 0xb1, IOBus::portout, DSK66::outB1H },
		{ 0xb2, IOBus::portout, DSK66::outB2H },
		{ 0xb3, IOBus::portout, DSK66::outB3H },
		{ 0xd0, IOBus::portout, DSK66::outD0H },
		{ 0xd1, IOBus::portout, DSK66::outD1H },
		{ 0xd2, IOBus::portout, DSK66::outD2H },
		{ 0xd3, IOBus::portout, DSK66::outD3H },
		{ 0xd6, IOBus::portout, DSK66::outD6H },
		{ 0xd8, IOBus::portout, DSK66::outD8H },
		{ 0xda, IOBus::portout, DSK66::outDAH },
		{ 0xdd, IOBus::portout, DSK66::outDDH },
		{ 0xde, IOBus::portout, DSK66::outDEH },
		{ 0xb2, IOBus::portin,  DSK66::inB2H },
		{ 0xd0, IOBus::portin,  DSK66::inD0H },
		{ 0xd1, IOBus::portin,  DSK66::inD1H },
		{ 0xd2, IOBus::portin,  DSK66::inD2H },
		{ 0xd3, IOBus::portin,  DSK66::inD3H },
		{ 0xd4, IOBus::portin,  DSK66::inD4H },
		{ 0xdc, IOBus::portin,  DSK66::inDCH },
		{ 0xdd, IOBus::portin,  DSK66::inDDH },
		{ 0, 0, 0 }	};
	if( !io->Connect( (DSK66*)disk, c_disk ) ) return FALSE;
	if( !disk->Init() ) return FALSE;
	// ɥ饤1DISK
	if( *cGlobal::DiskFile[0] ) DiskInsert( 0, cGlobal::DiskFile[0] );
	
	// CMT(LOAD) -----
	const static IOBus::Connector c_cmt[] = {
		{ 0xb0, IOBus::portout, CMTL::outB0H },
		{ 0, 0, 0 }	};
	if( !io->Connect( cmt, c_cmt ) ) return FALSE;
	
	Reset();
	
	// ꡼󥵥ѹ
	graph->ResizeScreen();
	
	// 顼ʤ
	Error::SetError( Error::NoError );
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ʬ
////////////////////////////////////////////////////////////////
BOOL VM6::InitCommon( void )
{
	// 󥽡ѥեɹ
	if( !JFont::OpenFont( cGlobal::GetFontFileZ(), cGlobal::GetFontFileH() ) ){
		Error::SetError( Error::FontFailed );
		return FALSE;
	}
	
	#ifdef USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	// ֥졼ݥ -----
	bp = new BPoint();
	if( !bp ) return FALSE;
	bp->ClearStatus();
	
	// 쥸ɥ -----
	regw = new cWndReg( this, DEV_ID('R', 'E', 'G', 'W') );
	if( !regw || !regw->Init() ) return FALSE;
	
	// ꥦɥ -----
	memw = new cWndMem( this, DEV_ID('M', 'E', 'M', 'W') );
	if( !memw || !memw->Init() ) return FALSE;
	
	// ˥ɥ -----
	monw = new cWndMon( this, DEV_ID('M', 'O', 'N', 'W') );
	if( !monw || !monw->Init() ) return FALSE;
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
	// I/O(Z80)-----
	if( !io->Init( 256 ) ) return FALSE;
	
	// I/O(SUB CPU)-----
	if( !ios->Init( 10 ) ) return FALSE;
	
	//  -----
	if( !intr->Init() ) return FALSE;
	
	// 塼 -----
	if( !sche->Init( CPU_CLOCK * cGlobal::OverClock / 100 ) ) return FALSE;
	
	//  -----
	if( !snd->Init( this, VM6::StreamUpdate, cGlobal::SampleRate, cGlobal::SoundBuffer ) ) return FALSE;
	snd->SetVolume( cGlobal::MasterVol );
	
	// CPU -----
	if( !cpu->Init() ) return FALSE;
	
	// SUB CPU -----
	if( !subcpu->Init() ) return FALSE;
	
	//  -----
	if( !mem->Init( cGlobal::RomPath, cGlobal::CheckCRC ) ) return FALSE;
	if( *cGlobal::ExtRomFile ) if( !mem->MountExtRom( cGlobal::ExtRomFile ) ) return FALSE;
	
	// VDG -----
	if( !vdg->Init() ) return FALSE;
	vdg->SetMode4Color( cGlobal::Mode4Color );
	
	//  -----
	if( !graph->Init( cGlobal::ScrBpp, cGlobal::ScanLineBr ) ) return FALSE;
	
	// PSG -----
	if( !psg->Init() ) return FALSE;
	psg->SetVolume( cGlobal::PsgVol );
	
	// 8255 -----
	if( !pio->Init() ) return FALSE;
	
	//  -----
	if( !key->Init( cGlobal::KeyRepeat, cGlobal::UsePS2KBD ) ) return FALSE;
	key->SetVKeySymbols( cGlobal::GetVKeySymbol() );	// ۥ -> P6 
	
	
	// CMT(LOAD) -----
	if( !cmt->Init() ) return FALSE;
	cmt->SetVolume( cGlobal::CmtVol );
	cmt->SetBoost( cGlobal::BoostUp );
	cmt->SetMaxBoost( cGlobal::MaxBoost1, cGlobal::MaxBoost2 );
	// TAPE
	if( *cGlobal::TapeFile ) TapeInsert( cGlobal::TapeFile );
	
	// CMT(SAVE) -----
	if( !cmts->Init( cGlobal::SaveFile ) ) return FALSE;
	
	// ơС -----
	if( !staw->Init() ) return FALSE;
	
	// FPSɽ
	if( !SetFPSTimer( 1 ) ){
		Stop();
		return FALSE;
	}
	
	// ӥǥץ -----
	if( !AVI6::Init() ) return FALSE;
	
	// ץ쥤 -----
	if( !REPLAY::Init( key->GetMatrixSize() ) ) return FALSE;
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ư
////////////////////////////////////////////////////////////////
BOOL VM6::Start( void )
{
	FSkipCount = 0;
	
	// å
	if( !this->SThread::BeginThread( this ) ) return FALSE;
	this->SThread::Start();
	
	sche->Start();
	snd->Play();
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ư
////////////////////////////////////////////////////////////////
void VM6::Stop( void )
{
	this->SThread::Cancel();	// åɽλե饰ΩƤ
	this->SThread::Waiting();	// åɽλޤԤ
	
	snd->Pause();
	sche->Stop();
	
	FSkipCount = 0;
}


////////////////////////////////////////////////////////////////
// ꥻå
////////////////////////////////////////////////////////////////
void VM6::Reset( void )
{
	cpu->Reset();
	intr->Reset();
	mem->Reset();
	subcpu->Reset();
	pio->Reset();
	psg->Reset();
	disk->Init();
	cmt->Reset();
	// ƥǥäƤ饪ȥ̵
	if( !disk->IsSystem(0) && !disk->IsSystem(1) ) cmt->SetAutoStart( cGlobal::P6Model );
	if( voice ) voice->Reset();
}


////////////////////////////////////////////////////////////////
// ǹ
////////////////////////////////////////////////////////////////
BOOL VM6::AutoType( char *filename )
{
	return key->SetAutoKeyFile( filename );
}


////////////////////////////////////////////////////////////////
// TAPE 
////////////////////////////////////////////////////////////////
BOOL VM6::TapeInsert( char *filename )
{
	// TAPEޥ
	if( !cmt->Mount( filename ) ){
		cmt->Unmount();
		return FALSE;
	}
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// TAPE ӽ
////////////////////////////////////////////////////////////////
void VM6::TapeEject( void )
{
	cmt->Unmount();
}


////////////////////////////////////////////////////////////////
// DISK 
////////////////////////////////////////////////////////////////
BOOL VM6::DiskInsert( int drvno, char *filename )
{
	if( !disk->Mount( drvno, filename ) ){
		disk->Unmount( drvno );
		return FALSE;
	}
	return TRUE;
}


////////////////////////////////////////////////////////////////
// DISK ӽ
////////////////////////////////////////////////////////////////
void VM6::DiskEject( int drvno )
{
	disk->Unmount( drvno );
}


////////////////////////////////////////////////////////////////
// ĥROM 
////////////////////////////////////////////////////////////////
BOOL VM6::ExtRomInsert( char *filename )
{
	// ĥROMޥ
	if( !mem->MountExtRom( filename ) ){
		mem->UnmountExtRom();
		return FALSE;
	}
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ĥROM ӽ
////////////////////////////////////////////////////////////////
void VM6::ExtRomEject( void )
{
	mem->UnmountExtRom();
}


////////////////////////////////////////////////////////////////
// ٥ȥ롼
////////////////////////////////////////////////////////////////
BOOL VM6::EventLoop( void )
{
	SDL_Event event;
	
	while( SDL_WaitEvent( &event ) ){
		switch( event.type ){
		case SDL_FPSUPDATE:		// FPSɽ
			{
			char str[256];
			sprintf( str, "%s (%d%%  %d/%d fps)", cGlobal::WCaption, sche->GetRatio(), event.user.code, FRAMERATE );
			SDL_WM_SetCaption( str, "" );
			}
			break;
			
		case SDL_KEYDOWN:		// 
			#ifdef USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
			// ˥⡼?
			if( cGlobal::MonDisp ){
				monw->KeyIn( &event );
				break;
			}else
			#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
			// Ƽﵡǽå
			if( CheckFuncKey( &event ) ) break;
		case SDL_KEYUP:
		case SDL_JOYAXISMOTION:
		case SDL_JOYBUTTONDOWN:
		case SDL_JOYBUTTONUP:
			if( REPLAY::GetStatus() != REP_REPLAY )	// ץ쥤Ǥʤ
				key->UpdateMatrix( &event );		// ޥȥꥯ
			break;
			
		#ifdef USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
		case SDL_DEBUGMODEBP:	// ˥⡼ѹ(֥졼ݥã)
			monw->BreakIn( event.user.code );	// ֥졼ݥȤξɽ
			ToggleMonitor();					// ˥⡼ѹ
			
			break;
			
		#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
		case SDL_MOUSEBUTTONUP:	// ޥܥ󥯥å
			if( ( event.button.button == SDL_BUTTON_RIGHT ) && ( event.button.state == SDL_RELEASED ) ){
				Stop();
				
				// ݥåץåץ˥塼ɽ
				ShowPopupMenu( event.button.x, event.button.y );
				
				Start();
			}
			break;
			
		case SDL_QUIT:			// λ
			if( cGlobal::CkQuit )
				if( OSD_Message( MSG_QUIT, MSG_QUITC, OSDM_YESNO | OSDM_ICONQUESTION ) != OSDR_YES )
					break;
			return FALSE;
			
		case SDL_RESTART:		// Ƶư
			return TRUE;
		}
		
		// 顼
		if( Error::GetError() != Error::NoError ){
			OSD_Message( (char *)Error::GetErrorText(), MSERR_ERROR, OSDR_OK | OSDM_ICONERROR );
			Error::SetError( Error::NoError );
		}
	}
	return FALSE;
}


////////////////////////////////////////////////////////////////
// Ƽﵡǽå
////////////////////////////////////////////////////////////////
BOOL VM6::CheckFuncKey( SDL_Event *event )
{
	// ALTξ֤
	BOOL OnALT  = event->key.keysym.mod & KMOD_ALT  ? TRUE : FALSE;
#ifdef __APPLE__
	// METAξ֤
	BOOL OnMETA = event->key.keysym.mod & KMOD_META ? TRUE : FALSE;
#endif
	
	switch( event->key.keysym.sym ){	// 
	case SDLK_F6:		// ˥⡼ѹ or ꡼⡼ѹ
		// ӥǥץ̵
		if( AVI6::IsAVI() ) return FALSE;
		
		if( OnALT ){
			Stop();
			cGlobal::FullScreen = cGlobal::FullScreen ? FALSE : TRUE;
			graph->ResizeScreen();	// ꡼󥵥ѹ
			Start();
		}else{
			#ifdef USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
			ToggleMonitor();
			#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
		}
		break;
		
	case SDLK_F7:			// 饤⡼ѹ
		// ӥǥץ̵
		if( AVI6::IsAVI() ) return FALSE;
		
		Stop();
		if( OnALT ){
			cGlobal::DispNTSC = cGlobal::DispNTSC ? FALSE : TRUE;
		}else{
			cGlobal::ScanLine = cGlobal::ScanLine ? FALSE : TRUE;
		}
		graph->ResizeScreen();	// ꡼󥵥ѹ
		Start();
		break;
		
	case SDLK_F8:			// ⡼4顼ѹ or ơСɽѹ
		if( OnALT ){
			Stop();
			cGlobal::StatDisp = cGlobal::StatDisp ? FALSE : TRUE;
			graph->ResizeScreen();	// ꡼󥵥ѹ
			Start();
		}else{
			int c = vdg->GetMode4Color();
			if( ++c > 4 ) c = 0;
			vdg->SetMode4Color( c );
		}
		break;
		
	case SDLK_F10:			// Wait̵ͭѹ
		if( OnALT ){
		}else{
			sche->SetWaitEnable( sche->GetWaitEnable() ? FALSE : TRUE );
		}
		break;
		
	case SDLK_F11:			// ꥻå
		if( OnALT ){
		}else{
			Reset();
		}
		break;
		
	case SDLK_F12:			// ʥåץå
		if( OnALT ){
		}else{
			graph->SnapShot( cGlobal::ImgPath );
		}
		break;
		
#ifdef __APPLE__
	// Mac Ǥ Cmd(Meta)+Q ץꥱνλ (by Windy)
	case SDLK_q:
		if( OnMETA ){
			SENDEVENT( SDL_QUIT );
			break;	// break ʤȡCmd+Q 򲡤ȤˡQ ϤƤޤ   add Windy  2007/4/24
		}
		
	// Cmd(Meta)SpaceǤ⡢ʥȤư롣(by Windy
	case SDLK_SPACE:
		if( OnMETA ){
			event->key.keysym.sym = SDLK_PAUSE;
		}
#endif
		
	default:				// ɤǤʤ
		return FALSE;
	}
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ̹
////////////////////////////////////////////////////////////////
BOOL VM6::ScreenUpdate( void )
{
	// ե졼ॹåץå
	if( ++FSkipCount > cGlobal::FrameSkip ){
		vdg->UpdateBackBuf();	// ХåХåե
		graph->DrawScreen();	// 
		
		#ifdef USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
		if( cGlobal::MonDisp ){
			regw->Update();
			memw->Update();
			monw->Update();
		}
		#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
		
		UDFPSCount++;
		FSkipCount = 0;
		
		return TRUE;
	}
	return FALSE;
}


////////////////////////////////////////////////////////////////
// ɹ
//
// :	samples		륵ץ(-1:ĤХåե 0:åʬ)
//			exbuf		Хåե
// :	int			ץ
////////////////////////////////////////////////////////////////
int VM6::SoundUpdate( int samples, cRing *exbuf )
{
	// PSG
	psg->SoundUpdate( samples );
	
	// 
//	if( voice ) voice->SoundUpdate( samples );
	
	// ɥХåե
	return snd->PreUpdate( psg->SndDev::cRing::ReadySize(), exbuf );
}


////////////////////////////////////////////////////////////////
// ȥ꡼๹ Хåؿ
//
// :	userdata	ʬȤؤΥ֥ȥݥ
//			stream		ȥ꡼ߥХåեؤΥݥ
//			len			Хåե(Хñ)
// :	ʤ
////////////////////////////////////////////////////////////////
void VM6::StreamUpdate( void *userdata, Uint8 *stream, int len )
{
	VM6 *p6 = (VM6 *)userdata;			// ʬȤΥ֥ȥݥ󥿼
	
	// ɥХåե
	//  ⤷ץ­ʤФɲ
	//  ӥǥץ̵
	int addsam = (int)(len/sizeof(Sint16)) - (int)(p6->snd->cRing::ReadySize());
	if( addsam > 0 && !p6->AVI6::IsAVI() ) p6->SoundUpdate( addsam );
	
	p6->snd->Update( stream, len/sizeof(Sint16) );
}


////////////////////////////////////////////////////////////////
// FPSɽ Хåؿ
////////////////////////////////////////////////////////////////
Uint32 VM6::UpDateFPS( Uint32 interval, void *obj )
{
	VM6 *p6 = (VM6 *)obj;	// ʬȤΥ֥ȥݥ󥿼
	
	SENDEVENT1( SDL_FPSUPDATE, p6->UDFPSCount )
	p6->UDFPSCount = 0;
	
	return interval;
}


////////////////////////////////////////////////////////////////
// FPSɽ
////////////////////////////////////////////////////////////////
BOOL VM6::SetFPSTimer( int fps )
{
	// ޲ưʤ
	if( UpDateFPSID ){
		SDL_RemoveTimer( UpDateFPSID );
		UpDateFPSID = NULL;
		SDL_EventState( SDL_FPSUPDATE, SDL_IGNORE );
	}
	
	// 
	if( fps > 0 ){
		UpDateFPSID = SDL_AddTimer( 1000/fps, VM6::UpDateFPS, this );
		if( !UpDateFPSID ) return FALSE;
		
		SDL_EventState( SDL_FPSUPDATE, SDL_ENABLE );
	}
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ɤǤSAVE
//
// :	filename	ե̾
// :	BOOL		TRUE: FALSE:
////////////////////////////////////////////////////////////////
BOOL VM6::DokoDemoSave( char *filename )
{
	cIni *Ini = NULL;
	
	// Ȥꤢ顼
	Error::SetError( Error::DokoWriteFailed );
	try{
		FILE *fp = FOPENEN( filename, "wt" );
		if( !fp ) throw Error::DokoWriteFailed;
		// ȥԤϤưöĤ
		fprintf( fp, MSDOKO_TITLE );
		fclose( fp );
		
		// ɤǤSAVEե򳫤
		Ini = new cIni();
		if( !Ini->Init( filename ) ) throw Error::DokoWriteFailed;
		
		if( !cGlobal::DokoSave( Ini ) ||
			!sche->DokoSave( Ini ) ||
			!psg->DokoSave( Ini ) ||
			!disk->DokoSave( Ini ) ||
			!vdg->DokoSave( Ini ) ||
			!intr->DokoSave( Ini ) ||
			!key->DokoSave( Ini ) ||
			!subcpu->DokoSave( Ini ) ||
			!pio->DokoSave( Ini ) ||
			!cpu->DokoSave( Ini ) ||
			!mem->DokoSave( Ini ) ||
			!cmt->DokoSave( Ini )
		) throw Error::GetError();
	}
	catch( std::bad_alloc ){	// new ˼Ԥ
		Error::SetError( Error::MemAllocFailed );
		return FALSE;
	}
	catch( Error::Errno i ){	// 㳰ȯ
		Error::SetError( i );
		if( Ini ) delete Ini;
		return FALSE;
	}
	
	Ini->Write();
	
	delete Ini;
	
	// ̵äΤǥ顼ʤ
	Error::SetError( Error::NoError );
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ɤǤLOAD
//
// :	filename	ե̾
// :	BOOL		TRUE: FALSE:
////////////////////////////////////////////////////////////////
BOOL VM6::DokoDemoLoad( char *filename )
{
	cIni *Ini = NULL;
	
	// Ȥꤢ顼
	Error::SetError( Error::DokoReadFailed );
	try{
		// ɤǤLOADե򳫤
		Ini = new cIni();
		if( !Ini->Init( filename ) ) throw Error::DokoReadFailed;
		
		if( !cGlobal::DokoLoad( Ini ) ) throw Error::GetError();
		
		Reset();
		
		if( !cGlobal::DokoLoad( Ini ) ||
			!sche->DokoLoad( Ini ) ||
			!psg->DokoLoad( Ini ) ||
			!disk->DokoLoad( Ini ) ||
			!vdg->DokoLoad( Ini ) ||
			!intr->DokoLoad( Ini ) ||
			!key->DokoLoad( Ini ) ||
			!subcpu->DokoLoad( Ini ) ||
			!pio->DokoLoad( Ini ) ||
			!cpu->DokoLoad( Ini ) ||
			!mem->DokoLoad( Ini ) ||
			!cmt->DokoLoad( Ini )
		) throw Error::GetError();
	}
	catch( std::bad_alloc ){	// new ˼Ԥ
		Error::SetError( Error::MemAllocFailed );
		return FALSE;
	}
	catch( Error::Errno i ){	// 㳰ȯ
		Error::SetError( i );
		if( Ini ) delete Ini;
		return FALSE;
	}
	
	delete Ini;
	
	// ̵äΤǥ顼ʤ
	Error::SetError( Error::NoError );
	
	return TRUE;
}
