#include <stdio.h>
#include <stdlib.h>
#include <errno.h>

#include "pc6001v.h"
#include "console.h"
#include "osd.h"
#include "pc60.h"

#include "icons.h"

#include "error.h"


///////////////////////////////////////////////////////////
// ᥤ
///////////////////////////////////////////////////////////
int main( int argc, char *argv[] )
{
	VM6 *P6Core = NULL;		// ֥ȥݥ
	BOOL Restart;			// Ƶưե饰
	
	
	// Ķѿ
//	putenv( "SDL_VIDEODRIVER=windib" );
//	putenv( "SDL_VIDEODRIVER=directx" );
//	putenv( "SDL_AUDIODRIVER=dsound" );
	
	// ŵưػ
	if( OSD_IsWorking() ) return FALSE;
	
	// SDL
	if( SDL_Init( SDL_INIT_TIMER | SDL_INIT_AUDIO | SDL_INIT_VIDEO | SDL_INIT_JOYSTICK ) < 0 ){
		Error::SetError( Error::SDLInitFailed );
		OSD_Message( (char *)Error::GetErrorText(), MSERR_ERROR, OSDR_OK | OSDM_ICONERROR );
		return FALSE;
	}
	
	// P6֥Ȥ
	do{
		Restart = FALSE;
		
		// INIեɹ
		if( !cGlobal::LoadIniFile() ){
			Error::SetError( Error::IniDefault );
			OSD_Message( (char *)Error::GetErrorText(), MSERR_ERROR, OSDR_OK | OSDM_ICONWARNING );
			Error::SetError( Error::NoError );
		}
		
		// եȥե뤬̵к
		if( !OSD_FileExist( cGlobal::GetFontFileH() ) ) OSD_CreateFont( cGlobal::GetFontFileH(), NULL, FSIZE );
		if( !OSD_FileExist( cGlobal::GetFontFileZ() ) ) OSD_CreateFont( NULL, cGlobal::GetFontFileZ(), FSIZE );
		
		// ROMե¸ߥå&ѹ
		char RomSerch[PATH_MAX];
		int IniModel = cGlobal::GetModel();
		sprintf( RomSerch, "%s*.%2d", cGlobal::GetRomPath(), IniModel );
		if( !OSD_FileExist( RomSerch ) ){
			int models[] = { 60, 62, 66 };
			for( int i=0; i < (int)(sizeof(models)/sizeof(int)); i++ ){
				sprintf( RomSerch, "%s*.%2d", cGlobal::GetRomPath(), models[i] );
				if( OSD_FileExist( RomSerch ) ){
					cGlobal::SetModel( models[i] );
					break;
				}
			}
			// ROM?
			if( IniModel != cGlobal::GetModel() ){
				Error::SetError( Error::RomChange );
				OSD_Message( (char *)Error::GetErrorText(), MSERR_ERROR, OSDR_OK | OSDM_ICONWARNING );
				Error::SetError( Error::NoError );
			}
		}
		
		// P6֥ȳ
		Uint8 *ipix, *imsk;
		switch( cGlobal::GetModel() ){
		case 62: P6Core = new VM62; ipix = p62pix; imsk = p62msk; break;
		case 66: P6Core = new VM66; ipix = p66pix; imsk = p66msk; break;
		default: P6Core = new VM60; ipix = p60pix; imsk = p60msk;
		}
		
		// 
		SDL_Surface *p6icon = SDL_CreateRGBSurfaceFrom( ipix, 32, 32, 24, 32*3, 0, 0, 0, 0 );
		SDL_WM_SetIcon( p6icon, imsk );
		SDL_FreeSurface( p6icon );
		
		// VMƼ¹
		if( P6Core->Init() ){
			P6Core->Start();
			Restart = P6Core->EventLoop();
			P6Core->Stop();
		}else{
			// Ԥ
			OSD_Message( (char *)Error::GetErrorText(), MSERR_ERROR, OSDR_OK | OSDM_ICONERROR );
		}
		
		// P6֥Ȥ
		if( P6Core ) delete P6Core;
		
		cGlobal::UnInit();
		
	}while( Restart );
	
	// SDLåȥ
	SDL_Quit();
	
	// λ
	OSD_Finish();
	
	return TRUE;
}
