#include <new>
#include "stdlib.h"     // add windy for strtol

#include "pc6001v.h"
#include "replay.h"
#include "common.h"
#include "error.h"


////////////////////////////////////////////////////////////////
// 󥹥ȥ饯
////////////////////////////////////////////////////////////////
REPLAY::REPLAY( void )
{
	Ini     = NULL;
	RepST   = REP_IDLE;
	Matrix  = NULL;
	MSize   = 0;
	RepFrm  = 0;
	EndFrm  = 0;
}


////////////////////////////////////////////////////////////////
// ǥȥ饯
////////////////////////////////////////////////////////////////
REPLAY::~REPLAY( void )
{
	switch( RepST ){
	case REP_RECORD:	StopRecord(); break;
	case REP_REPLAY:	StopReplay(); break;
	}
	if( Matrix ) delete [] Matrix;
	if( Ini ) delete Ini;
}


////////////////////////////////////////////////////////////////
// 
//
// :	msize	ޥȥꥯ
// :	BOOL	TRUE: FALSE:
////////////////////////////////////////////////////////////////
BOOL REPLAY::Init( int msize )
{
	PRINTD( GRP_LOG, "[REPLAY][Init]\n" );
	
	if( Ini ) delete Ini;
	Ini = NULL;
	
	if( Matrix ) delete [] Matrix;
	Matrix = new BYTE[msize];
	if( !Matrix ) return FALSE;
	
	RepST   = REP_IDLE;
	MSize   = msize;
	RepFrm  = 0;
	EndFrm  = 0;
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ơ
//
// :	ʤ
// :	int		ơ
////////////////////////////////////////////////////////////////
BOOL REPLAY::GetStatus( void )
{
	return RepST;
}


////////////////////////////////////////////////////////////////
// ץ쥤Ͽ
//
// :	filename	ϥե̾
// :	BOOL		TRUE: FALSE:
////////////////////////////////////////////////////////////////
BOOL REPLAY::StartRecord( char *filename )
{
	// Ȥꤢ顼
	Error::SetError( Error::ReplayPlayError );
	try{
		if( RepST != REP_IDLE ) throw Error::ReplayRecError;
		
		Ini = new cIni();
		if( !Ini->Init( filename ) ) throw Error::ReplayRecError;
	}
	catch( std::bad_alloc ){	// new ˼Ԥ
		Error::SetError( Error::MemAllocFailed );
		return FALSE;
	}
	catch( Error::Errno i ){	// 㳰ȯ
		Error::SetError( i );
		if( Ini ) delete Ini;
		Ini = NULL;
		return FALSE;
	}
	
	memset( Matrix, 0xff, MSize );		// ޥȥꥯХåեꥢ
	
	RepFrm = 0;
	RepST  = REP_RECORD;
	
	// ̵äΤǥ顼ʤ
	Error::SetError( Error::NoError );
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ץ쥤Ͽ
//
// :	ʤ
// :	ʤ
////////////////////////////////////////////////////////////////
void REPLAY::StopRecord( void )
{
	if( RepST != REP_RECORD ) return;
	
	if( Ini ){
		Ini->PutEntry( "REPLAY", NULL, "EndFrm", "0x%08lX", RepFrm );
		
		Ini->Write();
		
		delete Ini;
		Ini = NULL;
	}
	
	RepST = REP_IDLE;
}


////////////////////////////////////////////////////////////////
// ץ쥤1ե졼Ф
//
// :	mt		ޥȥꥯݥ
// 			chg		ޥȥꥯѲ TRUE: FALSE:ʤ
// :	BOOL	TRUE: FALSE:
////////////////////////////////////////////////////////////////
BOOL REPLAY::ReplayWriteFrame( BYTE *mt, BOOL chg )
{
	char stren[16],strva[256];
	
	if( ( RepST != REP_RECORD ) || !mt || !Ini ) return FALSE;
	
	// ޥȥꥯѲäФ
	if( chg ){
		sprintf( stren, "%08lX ", RepFrm );
		for( int i=0; i<MSize; i++ )
			sprintf( strva+i*2, "%02X", mt[i] );
		Ini->PutEntry( "REPLAY", NULL, stren, "%s", strva );
	}
	
	RepFrm++;
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ץ쥤
//
// :	filename	ϥե̾
// :	BOOL		TRUE: FALSE:
////////////////////////////////////////////////////////////////
BOOL REPLAY::StartReplay( char *filename )
{
	// Ȥꤢ顼
	Error::SetError( Error::ReplayPlayError );
	try{
		int st;	// ۥȤDWORD
		
		if( RepST != REP_IDLE ) throw Error::ReplayPlayError;
		
		Ini = new cIni();
		if( !Ini->Init( filename ) ) throw Error::ReplayPlayError;
		
		if( !Ini->GetInt( "REPLAY", "EndFrm", &st, EndFrm ) ) throw Error::NoReplayData;
		else                                                  EndFrm = st;
	}
	catch( std::bad_alloc ){	// new ˼Ԥ
		Error::SetError( Error::MemAllocFailed );
		return FALSE;
	}
	catch( Error::Errno i ){	// 㳰ȯ
		Error::SetError( i );
		if( Ini ) delete Ini;
		Ini = NULL;
		return FALSE;
	}
	
	memset( Matrix, 0xff, MSize );	// ޥȥꥯХåեꥢ
	
	RepFrm = 0;
	RepST  = REP_REPLAY;
	
	// ̵äΤǥ顼ʤ
	Error::SetError( Error::NoError );
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ץ쥤
//
// :	ʤ
// :	ʤ
////////////////////////////////////////////////////////////////
void REPLAY::StopReplay( void )
{
	if( RepST != REP_REPLAY ) return;
	
	if( Ini ){
		delete Ini;
		Ini = NULL;
	}
	
	RepST = REP_IDLE;
}


////////////////////////////////////////////////////////////////
// ץ쥤1ե졼ɹ
//
// :	mt		ޥȥꥯݥ
// :	BOOL	TRUE: FALSE:
////////////////////////////////////////////////////////////////
BOOL REPLAY::ReplayReadFrame( BYTE *mt )
{
	char stren[16],strva[256];
	
	if( ( RepST != REP_REPLAY ) || !mt || !Ini ) return FALSE;
	
	sprintf( stren, "%08lX", RepFrm );
	if( Ini->GetString( "REPLAY", stren, strva, "" ) ){
		int stl = strlen( strva ) / 2;
		for( int i=0; i<stl; i++ ){
			char dt[3] = "FF";
			strncpy( dt, &strva[i*2], 2 );
			Matrix[i] = strtol( dt, NULL, 16 );
		}
		memcpy( mt, Matrix, MSize );
	}
	
	if( ++RepFrm >= EndFrm ){
		// ǡüãץ쥤λ
		StopReplay();
	}
	
	return TRUE;
}
